/* SnapshotRepo.c generated by valac 0.54.7, the Vala compiler
 * generated from SnapshotRepo.vala, do not modify */

/*
 * SnapshotRepo.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TEE_JEE_FILE_SYSTEM_KB ((gint64) 1000)
#define TEE_JEE_FILE_SYSTEM_MB (1000 * TEE_JEE_FILE_SYSTEM_KB)
#define TEE_JEE_FILE_SYSTEM_GB (1000 * TEE_JEE_FILE_SYSTEM_MB)
#define MAIN_MIN_FREE_SPACE ((guint64) (1 * TEE_JEE_FILE_SYSTEM_GB))
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SNAPSHOT_REPO (snapshot_repo_get_type ())
#define SNAPSHOT_REPO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SNAPSHOT_REPO, SnapshotRepo))
#define SNAPSHOT_REPO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SNAPSHOT_REPO, SnapshotRepoClass))
#define IS_SNAPSHOT_REPO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SNAPSHOT_REPO))
#define IS_SNAPSHOT_REPO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SNAPSHOT_REPO))
#define SNAPSHOT_REPO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SNAPSHOT_REPO, SnapshotRepoClass))

typedef struct _SnapshotRepo SnapshotRepo;
typedef struct _SnapshotRepoClass SnapshotRepoClass;
typedef struct _SnapshotRepoPrivate SnapshotRepoPrivate;

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;

#define TYPE_SNAPSHOT (snapshot_get_type ())
#define SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SNAPSHOT, Snapshot))
#define SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SNAPSHOT, SnapshotClass))
#define IS_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SNAPSHOT))
#define IS_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SNAPSHOT))
#define SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SNAPSHOT, SnapshotClass))

typedef struct _Snapshot Snapshot;
typedef struct _SnapshotClass SnapshotClass;
typedef enum  {
	SNAPSHOT_LOCATION_STATUS_NOT_SELECTED = -2,
	SNAPSHOT_LOCATION_STATUS_NOT_AVAILABLE = -1,
	SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_HAS_SPACE = 0,
	SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_NO_SPACE = 1,
	SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_NO_SPACE = 2,
	SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_HAS_SPACE = 3,
	SNAPSHOT_LOCATION_STATUS_READ_ONLY_FS = 4,
	SNAPSHOT_LOCATION_STATUS_HARDLINKS_NOT_SUPPORTED = 5,
	SNAPSHOT_LOCATION_STATUS_NO_BTRFS_SYSTEM = 6
} SnapshotLocationStatus;

#define TYPE_SNAPSHOT_LOCATION_STATUS (snapshot_location_status_get_type ())
enum  {
	SNAPSHOT_REPO_0_PROPERTY,
	SNAPSHOT_REPO_TIMESHIFT_PATH_PROPERTY,
	SNAPSHOT_REPO_SNAPSHOTS_PATH_PROPERTY,
	SNAPSHOT_REPO_NUM_PROPERTIES
};
static GParamSpec* snapshot_repo_properties[SNAPSHOT_REPO_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_MOUNT_ENTRY (mount_entry_get_type ())
#define MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ENTRY, MountEntry))
#define MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ENTRY, MountEntryClass))
#define IS_MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ENTRY))
#define IS_MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ENTRY))
#define MOUNT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ENTRY, MountEntryClass))

typedef struct _MountEntry MountEntry;
typedef struct _MountEntryClass MountEntryClass;

#define TYPE_SUBVOLUME (subvolume_get_type ())
#define SUBVOLUME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUBVOLUME, Subvolume))
#define SUBVOLUME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUBVOLUME, SubvolumeClass))
#define IS_SUBVOLUME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUBVOLUME))
#define IS_SUBVOLUME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUBVOLUME))
#define SUBVOLUME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUBVOLUME, SubvolumeClass))

typedef struct _Subvolume Subvolume;
typedef struct _SubvolumeClass SubvolumeClass;
typedef struct _SubvolumePrivate SubvolumePrivate;
typedef struct _SnapshotPrivate SnapshotPrivate;

#define TYPE_FS_TAB_ENTRY (fs_tab_entry_get_type ())
#define FS_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FS_TAB_ENTRY, FsTabEntry))
#define FS_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FS_TAB_ENTRY, FsTabEntryClass))
#define IS_FS_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FS_TAB_ENTRY))
#define IS_FS_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FS_TAB_ENTRY))
#define FS_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FS_TAB_ENTRY, FsTabEntryClass))

typedef struct _FsTabEntry FsTabEntry;
typedef struct _FsTabEntryClass FsTabEntryClass;

#define TYPE_CRYPT_TAB_ENTRY (crypt_tab_entry_get_type ())
#define CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntry))
#define CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))
#define IS_CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CRYPT_TAB_ENTRY))
#define IS_CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CRYPT_TAB_ENTRY))
#define CRYPT_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))

typedef struct _CryptTabEntry CryptTabEntry;
typedef struct _CryptTabEntryClass CryptTabEntryClass;

#define TYPE_LINUX_DISTRO (linux_distro_get_type ())
#define LINUX_DISTRO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINUX_DISTRO, LinuxDistro))
#define LINUX_DISTRO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINUX_DISTRO, LinuxDistroClass))
#define IS_LINUX_DISTRO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINUX_DISTRO))
#define IS_LINUX_DISTRO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINUX_DISTRO))
#define LINUX_DISTRO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINUX_DISTRO, LinuxDistroClass))

typedef struct _LinuxDistro LinuxDistro;
typedef struct _LinuxDistroClass LinuxDistroClass;

#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;

#define TYPE_DELETE_FILE_TASK (delete_file_task_get_type ())
#define DELETE_FILE_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELETE_FILE_TASK, DeleteFileTask))
#define DELETE_FILE_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELETE_FILE_TASK, DeleteFileTaskClass))
#define IS_DELETE_FILE_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELETE_FILE_TASK))
#define IS_DELETE_FILE_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELETE_FILE_TASK))
#define DELETE_FILE_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELETE_FILE_TASK, DeleteFileTaskClass))

typedef struct _DeleteFileTask DeleteFileTask;
typedef struct _DeleteFileTaskClass DeleteFileTaskClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define TYPE_MAIN (main_get_type ())
#define MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN, Main))
#define MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN, MainClass))
#define IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN))
#define IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN))
#define MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN, MainClass))

typedef struct _Main Main;
typedef struct _MainClass MainClass;
typedef struct _MainPrivate MainPrivate;

#define TYPE_APP_EXCLUDE_ENTRY (app_exclude_entry_get_type ())
#define APP_EXCLUDE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_EXCLUDE_ENTRY, AppExcludeEntry))
#define APP_EXCLUDE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_EXCLUDE_ENTRY, AppExcludeEntryClass))
#define IS_APP_EXCLUDE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_EXCLUDE_ENTRY))
#define IS_APP_EXCLUDE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_EXCLUDE_ENTRY))
#define APP_EXCLUDE_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_EXCLUDE_ENTRY, AppExcludeEntryClass))

typedef struct _AppExcludeEntry AppExcludeEntry;
typedef struct _AppExcludeEntryClass AppExcludeEntryClass;

#define TYPE_APP_LOCK (app_lock_get_type ())
#define APP_LOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_LOCK, AppLock))
#define APP_LOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_LOCK, AppLockClass))
#define IS_APP_LOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_LOCK))
#define IS_APP_LOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_LOCK))
#define APP_LOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_LOCK, AppLockClass))

typedef struct _AppLock AppLock;
typedef struct _AppLockClass AppLockClass;

#define TYPE_RSYNC_TASK (rsync_task_get_type ())
#define RSYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSYNC_TASK, RsyncTask))
#define RSYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSYNC_TASK, RsyncTaskClass))
#define IS_RSYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSYNC_TASK))
#define IS_RSYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSYNC_TASK))
#define RSYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSYNC_TASK, RsyncTaskClass))

typedef struct _RsyncTask RsyncTask;
typedef struct _RsyncTaskClass RsyncTaskClass;

#define TYPE_SYSTEM_USER (system_user_get_type ())
#define SYSTEM_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_USER, SystemUser))
#define SYSTEM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYSTEM_USER, SystemUserClass))
#define IS_SYSTEM_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_USER))
#define IS_SYSTEM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYSTEM_USER))
#define SYSTEM_USER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYSTEM_USER, SystemUserClass))

typedef struct _SystemUser SystemUser;
typedef struct _SystemUserClass SystemUserClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _SnapshotRepo {
	GObject parent_instance;
	SnapshotRepoPrivate * priv;
	Device* device;
	Device* device_home;
	gchar* mount_path;
	GeeHashMap* mount_paths;
	gboolean btrfs_mode;
	GeeArrayList* snapshots;
	GeeArrayList* invalid_snapshots;
	gchar* status_message;
	gchar* status_details;
	SnapshotLocationStatus status_code;
};

struct _SnapshotRepoClass {
	GObjectClass parent_class;
};

struct _SnapshotRepoPrivate {
	GtkWindow* parent_window;
	gboolean thr_success;
	gboolean thr_running;
	gchar* thr_args1;
};

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
	gchar* device;
	gchar* name;
	gchar* kname;
	gchar* pkname;
	gchar* pkname_toplevel;
	gchar* mapped_name;
	gchar* uuid;
	gchar* label;
	gchar* partuuid;
	gchar* partlabel;
	gint major;
	gint minor;
	gchar* device_mapper;
	gchar* device_by_uuid;
	gchar* device_by_label;
	gchar* device_by_partuuid;
	gchar* device_by_partlabel;
	gchar* type;
	gchar* fstype;
	gint order;
	gchar* vendor;
	gchar* model;
	gchar* serial;
	gchar* revision;
	gboolean removable;
	gboolean read_only;
	guint64 size_bytes;
	guint64 used_bytes;
	guint64 available_bytes;
	gchar* used_percent;
	gchar* dist_info;
	GeeArrayList* mount_points;
	GeeArrayList* symlinks;
	Device* parent;
	GeeArrayList* children;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _Subvolume {
	GObject parent_instance;
	SubvolumePrivate * priv;
	gchar* device_uuid;
	gchar* name;
	gchar* path;
	glong id;
	gint64 total_bytes;
	gint64 unshared_bytes;
	gchar* mount_path;
	SnapshotRepo* repo;
};

struct _SubvolumeClass {
	GObjectClass parent_class;
};

struct _Snapshot {
	GObject parent_instance;
	SnapshotPrivate * priv;
	gchar* path;
	gchar* name;
	GDateTime* date;
	gchar* sys_uuid;
	gchar* sys_distro;
	gchar* app_version;
	gchar* description;
	gint64 file_count;
	GeeArrayList* tags;
	GeeArrayList* exclude_list;
	GeeHashMap* subvolumes;
	GeeArrayList* fstab_list;
	GeeArrayList* cryttab_list;
	gboolean valid;
	gboolean live;
	gboolean marked_for_deletion;
	LinuxDistro* distro;
	SnapshotRepo* repo;
	gboolean btrfs_mode;
	GeeHashMap* paths;
	gchar* mount_path_root;
	gchar* mount_path_home;
	DeleteFileTask* delete_file_task;
};

struct _SnapshotClass {
	GObjectClass parent_class;
};

struct _Main {
	GObject parent_instance;
	MainPrivate * priv;
	gchar* app_path;
	gchar* share_folder;
	gchar* rsnapshot_conf_path;
	gchar* app_conf_path;
	gchar* app_conf_path_old;
	gchar* app_conf_path_default;
	gboolean first_run;
	gchar* backup_uuid;
	gchar* backup_parent_uuid;
	gboolean btrfs_mode;
	gboolean include_btrfs_home_for_backup;
	gboolean include_btrfs_home_for_restore;
	gboolean stop_cron_emails;
	GeeArrayList* partitions;
	GeeArrayList* exclude_list_user;
	GeeArrayList* exclude_list_default;
	GeeArrayList* exclude_list_default_extra;
	GeeArrayList* exclude_list_home;
	GeeArrayList* exclude_list_restore;
	GeeArrayList* exclude_list_apps;
	GeeArrayList* mount_list;
	GeeArrayList* exclude_app_names;
	SnapshotRepo* repo;
	Device* sys_root;
	Device* sys_boot;
	Device* sys_efi;
	Device* sys_home;
	GeeHashMap* sys_subvolumes;
	gchar* mount_point_restore;
	gchar* mount_point_app;
	LinuxDistro* current_distro;
	gboolean mirror_system;
	gboolean schedule_monthly;
	gboolean schedule_weekly;
	gboolean schedule_daily;
	gboolean schedule_hourly;
	gboolean schedule_boot;
	gint count_monthly;
	gint count_weekly;
	gint count_daily;
	gint count_hourly;
	gint count_boot;
	gboolean btrfs_use_qgroup;
	gchar* app_mode;
	gboolean dry_run;
	gboolean thr_success;
	gboolean thread_estimate_running;
	gboolean thread_estimate_success;
	gboolean thread_restore_running;
	gboolean thread_restore_success;
	gboolean thread_delete_running;
	gboolean thread_delete_success;
	gboolean thread_subvol_info_running;
	gboolean thread_subvol_info_success;
	gint thr_retval;
	gchar* thr_arg1;
	gboolean thr_timeout_active;
	gchar* thr_timeout_cmd;
	gint startup_delay_interval_mins;
	gint retain_snapshots_max_days;
	gint64 snapshot_location_free_space;
	gchar* log_dir;
	gchar* log_file;
	AppLock* app_lock;
	gchar* date_format;
	GeeArrayList* delete_list;
	Snapshot* snapshot_to_delete;
	Snapshot* snapshot_to_restore;
	gboolean reinstall_grub2;
	gboolean update_initramfs;
	gboolean update_grub;
	gchar* grub_device;
	gboolean use_option_raw;
	gboolean cmd_skip_grub;
	gchar* cmd_grub_device;
	gchar* cmd_target_device;
	gchar* cmd_backup_device;
	gchar* cmd_snapshot;
	gboolean cmd_confirm;
	gboolean cmd_verbose;
	gboolean cmd_scripted;
	gchar* cmd_comments;
	gchar* cmd_tags;
	gboolean* cmd_btrfs_mode;
	gchar* progress_text;
	GtkWindow* parent_window;
	RsyncTask* task;
	DeleteFileTask* delete_file_task;
	GeeHashMap* current_system_users;
	gchar* users_with_encrypted_home;
	gchar* encrypted_home_dirs;
	gboolean encrypted_home_warning_shown;
	gchar* encrypted_private_dirs;
	gboolean encrypted_private_warning_shown;
};

struct _MainClass {
	GObjectClass parent_class;
};

static gint SnapshotRepo_private_offset;
static gpointer snapshot_repo_parent_class = NULL;
VALA_EXTERN Main* App;
VALA_EXTERN guint64 main_first_snapshot_size;
VALA_EXTERN gboolean tee_jee_logging_LOG_COMMANDS;

VALA_EXTERN GType snapshot_repo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SnapshotRepo, g_object_unref)
VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType snapshot_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Snapshot, g_object_unref)
VALA_EXTERN GType snapshot_location_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SnapshotRepo* snapshot_repo_new_from_path (const gchar* path,
                                           GtkWindow* parent_win,
                                           gboolean _btrfs_mode);
VALA_EXTERN SnapshotRepo* snapshot_repo_construct_from_path (GType object_type,
                                                 const gchar* path,
                                                 GtkWindow* parent_win,
                                                 gboolean _btrfs_mode);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
VALA_EXTERN GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point);
VALA_EXTERN GType mount_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MountEntry, g_object_unref)
VALA_EXTERN gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
VALA_EXTERN guint64 device_get_free_bytes (Device* self);
VALA_EXTERN void snapshot_repo_check_status (SnapshotRepo* self);
VALA_EXTERN SnapshotRepo* snapshot_repo_new_from_device (Device* dev,
                                             GtkWindow* parent_win,
                                             gboolean btrfs_repo);
VALA_EXTERN SnapshotRepo* snapshot_repo_construct_from_device (GType object_type,
                                                   Device* dev,
                                                   GtkWindow* parent_win,
                                                   gboolean btrfs_repo);
static void snapshot_repo_init_from_device (SnapshotRepo* self);
VALA_EXTERN SnapshotRepo* snapshot_repo_new_from_uuid (const gchar* uuid,
                                           GtkWindow* parent_win,
                                           gboolean btrfs_repo);
VALA_EXTERN SnapshotRepo* snapshot_repo_construct_from_uuid (GType object_type,
                                                 const gchar* uuid,
                                                 GtkWindow* parent_win,
                                                 gboolean btrfs_repo);
VALA_EXTERN Device* device_get_device_by_uuid (const gchar* uuid);
VALA_EXTERN Device* device_new (void);
VALA_EXTERN Device* device_construct (GType object_type);
VALA_EXTERN SnapshotRepo* snapshot_repo_new_from_null (void);
VALA_EXTERN SnapshotRepo* snapshot_repo_construct_from_null (GType object_type);
VALA_EXTERN gboolean snapshot_repo_unlock_and_mount_devices (SnapshotRepo* self);
VALA_EXTERN gchar* snapshot_repo_unlock_and_mount_device (SnapshotRepo* self,
                                              Device* device_to_mount,
                                              const gchar* path_to_mount);
VALA_EXTERN GType subvolume_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Subvolume, g_object_unref)
VALA_EXTERN GeeHashMap* subvolume_detect_subvolumes_for_system_by_path (const gchar* system_path,
                                                            SnapshotRepo* repo,
                                                            GtkWindow* parent_window);
VALA_EXTERN gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
VALA_EXTERN Device* subvolume_get_device (Subvolume* self);
VALA_EXTERN gboolean snapshot_repo_load_snapshots (SnapshotRepo* self);
VALA_EXTERN gboolean device_is_encrypted_partition (Device* self);
VALA_EXTERN Device* snapshot_repo_unlock_encrypted_device (SnapshotRepo* self,
                                               Device* luks_device);
VALA_EXTERN gboolean device_mount (const gchar* dev_name_or_uuid,
                       const gchar* mount_point,
                       const gchar* mount_options,
                       gboolean silent);
VALA_EXTERN Device* device_luks_unlock (Device* luks_device,
                            const gchar* mapped_name,
                            const gchar* passphrase,
                            GtkWindow* parent_window,
                            gchar** message,
                            gchar** details);
VALA_EXTERN gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
VALA_EXTERN gchar* snapshot_repo_get_snapshots_path (SnapshotRepo* self);
VALA_EXTERN Snapshot* snapshot_new (const gchar* dir_path,
                        gboolean btrfs_snapshot,
                        SnapshotRepo* _repo);
VALA_EXTERN Snapshot* snapshot_construct (GType object_type,
                              const gchar* dir_path,
                              gboolean btrfs_snapshot,
                              SnapshotRepo* _repo);
VALA_EXTERN GType fs_tab_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FsTabEntry, g_object_unref)
VALA_EXTERN GType crypt_tab_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CryptTabEntry, g_object_unref)
VALA_EXTERN GType linux_distro_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LinuxDistro, g_object_unref)
VALA_EXTERN GType async_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AsyncTask, g_object_unref)
VALA_EXTERN GType delete_file_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DeleteFileTask, g_object_unref)
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
static gint __lambda8_ (SnapshotRepo* self,
                 Snapshot* a,
                 Snapshot* b);
static gint ___lambda8__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
VALA_EXTERN gdouble tee_jee_system_get_system_uptime_seconds (void);
VALA_EXTERN GType main_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Main, g_object_unref)
VALA_EXTERN GType app_exclude_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppExcludeEntry, g_object_unref)
VALA_EXTERN GType app_lock_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppLock, g_object_unref)
VALA_EXTERN GType rsync_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RsyncTask, g_object_unref)
VALA_EXTERN GType system_user_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SystemUser, g_object_unref)
VALA_EXTERN void snapshot_update_control_file (Snapshot* self);
VALA_EXTERN void main_query_subvolume_info (Main* self,
                                SnapshotRepo* parent_repo);
VALA_EXTERN GeeArrayList* snapshot_repo_get_snapshots_by_tag (SnapshotRepo* self,
                                                  const gchar* tag);
VALA_EXTERN gboolean snapshot_has_tag (Snapshot* self,
                           const gchar* tag);
static gint __lambda9_ (SnapshotRepo* self,
                 Snapshot* a,
                 Snapshot* b);
static gint ___lambda9__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
VALA_EXTERN Snapshot* snapshot_repo_get_latest_snapshot (SnapshotRepo* self,
                                             const gchar* tag,
                                             const gchar* sys_uuid);
VALA_EXTERN Snapshot* snapshot_repo_get_oldest_snapshot (SnapshotRepo* self,
                                             const gchar* tag,
                                             const gchar* sys_uuid);
VALA_EXTERN gboolean snapshot_repo_available (SnapshotRepo* self);
VALA_EXTERN gboolean snapshot_repo_has_snapshots (SnapshotRepo* self);
VALA_EXTERN gboolean snapshot_repo_has_space (SnapshotRepo* self);
VALA_EXTERN gboolean snapshot_repo_has_btrfs_system (SnapshotRepo* self);
VALA_EXTERN void device_query_disk_space (Device* self);
VALA_EXTERN void snapshot_repo_print_status (SnapshotRepo* self);
VALA_EXTERN void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
VALA_EXTERN gchar* device_get_device_name_with_parent (Device* self);
VALA_EXTERN void snapshot_repo_auto_remove (SnapshotRepo* self);
VALA_EXTERN void snapshot_remove_tag (Snapshot* self,
                          const gchar* tag);
VALA_EXTERN void snapshot_repo_remove_untagged (SnapshotRepo* self);
VALA_EXTERN void snapshot_repo_remove_marked_for_deletion (SnapshotRepo* self);
VALA_EXTERN void snapshot_repo_remove_invalid (SnapshotRepo* self);
VALA_EXTERN gboolean snapshot_remove (Snapshot* self,
                          gboolean wait);
VALA_EXTERN gboolean snapshot_repo_remove_all (SnapshotRepo* self);
VALA_EXTERN gchar* snapshot_repo_get_timeshift_path (SnapshotRepo* self);
VALA_EXTERN gboolean snapshot_repo_remove_sync_dir (SnapshotRepo* self);
static gboolean snapshot_repo_delete_directory (SnapshotRepo* self,
                                         const gchar* dir_path);
VALA_EXTERN gboolean snapshot_repo_remove_timeshift_dir (SnapshotRepo* self);
static void snapshot_repo_delete_directory_thread (SnapshotRepo* self);
static gpointer _snapshot_repo_delete_directory_thread_gthread_func (gpointer self);
VALA_EXTERN void tee_jee_gtk_helper_gtk_do_events (void);
VALA_EXTERN void snapshot_repo_create_symlinks (SnapshotRepo* self);
VALA_EXTERN void snapshot_repo_cleanup_symlink_dir (SnapshotRepo* self,
                                        const gchar* tag);
VALA_EXTERN gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar** std_out,
                                       gchar** std_err);
VALA_EXTERN SnapshotRepo* snapshot_repo_new (void);
VALA_EXTERN SnapshotRepo* snapshot_repo_construct (GType object_type);
static void snapshot_repo_finalize (GObject * obj);
static GType snapshot_repo_get_type_once (void);
static void _vala_snapshot_repo_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
snapshot_repo_get_instance_private (SnapshotRepo* self)
{
	return G_STRUCT_MEMBER_P (self, SnapshotRepo_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 61 "Core/SnapshotRepo.vala"
	return self ? g_object_ref (self) : NULL;
#line 648 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_construct_from_path (GType object_type,
                                   const gchar* path,
                                   GtkWindow* parent_win,
                                   gboolean _btrfs_mode)
{
	SnapshotRepo * self = NULL;
	gchar* _tmp0_;
	GtkWindow* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 53 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 53 "Core/SnapshotRepo.vala"
	self = (SnapshotRepo*) g_object_new (object_type, NULL);
#line 55 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: from_path()");
#line 60 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup (path);
#line 60 "Core/SnapshotRepo.vala"
	_g_free0 (self->mount_path);
#line 60 "Core/SnapshotRepo.vala"
	self->mount_path = _tmp0_;
#line 61 "Core/SnapshotRepo.vala"
	_tmp1_ = _g_object_ref0 (parent_win);
#line 61 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 61 "Core/SnapshotRepo.vala"
	self->priv->parent_window = _tmp1_;
#line 62 "Core/SnapshotRepo.vala"
	self->btrfs_mode = _btrfs_mode;
#line 64 "Core/SnapshotRepo.vala"
	_tmp2_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 64 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->snapshots);
#line 64 "Core/SnapshotRepo.vala"
	self->snapshots = _tmp2_;
#line 65 "Core/SnapshotRepo.vala"
	_tmp3_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 65 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->invalid_snapshots);
#line 65 "Core/SnapshotRepo.vala"
	self->invalid_snapshots = _tmp3_;
#line 66 "Core/SnapshotRepo.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 66 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->mount_paths);
#line 66 "Core/SnapshotRepo.vala"
	self->mount_paths = _tmp4_;
#line 70 "Core/SnapshotRepo.vala"
	_tmp5_ = device_get_disk_space_using_df (path);
#line 70 "Core/SnapshotRepo.vala"
	list = _tmp5_;
#line 72 "Core/SnapshotRepo.vala"
	_tmp6_ = list;
#line 72 "Core/SnapshotRepo.vala"
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 72 "Core/SnapshotRepo.vala"
	_tmp8_ = _tmp7_;
#line 72 "Core/SnapshotRepo.vala"
	if (_tmp8_ > 0) {
#line 718 "SnapshotRepo.c"
		GeeArrayList* _tmp9_;
		gpointer _tmp10_;
		Device* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		Device* _tmp17_;
		guint64 _tmp18_;
		guint64 _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 74 "Core/SnapshotRepo.vala"
		_tmp9_ = list;
#line 74 "Core/SnapshotRepo.vala"
		_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, 0);
#line 74 "Core/SnapshotRepo.vala"
		_g_object_unref0 (self->device);
#line 74 "Core/SnapshotRepo.vala"
		self->device = (Device*) _tmp10_;
#line 76 "Core/SnapshotRepo.vala"
		_tmp11_ = self->device;
#line 76 "Core/SnapshotRepo.vala"
		_tmp12_ = _tmp11_->device;
#line 76 "Core/SnapshotRepo.vala"
		_tmp13_ = g_strdup_printf (": %s", _tmp12_);
#line 76 "Core/SnapshotRepo.vala"
		_tmp14_ = _tmp13_;
#line 76 "Core/SnapshotRepo.vala"
		_tmp15_ = g_strconcat (_ ("Device"), _tmp14_, NULL);
#line 76 "Core/SnapshotRepo.vala"
		_tmp16_ = _tmp15_;
#line 76 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp16_);
#line 76 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp16_);
#line 76 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp14_);
#line 77 "Core/SnapshotRepo.vala"
		_tmp17_ = self->device;
#line 77 "Core/SnapshotRepo.vala"
		_tmp18_ = device_get_free_bytes (_tmp17_);
#line 77 "Core/SnapshotRepo.vala"
		_tmp19_ = _tmp18_;
#line 77 "Core/SnapshotRepo.vala"
		_tmp20_ = tee_jee_file_system_format_file_size (_tmp19_, FALSE, "", TRUE, 1);
#line 77 "Core/SnapshotRepo.vala"
		_tmp21_ = _tmp20_;
#line 77 "Core/SnapshotRepo.vala"
		_tmp22_ = g_strdup_printf (": %s", _tmp21_);
#line 77 "Core/SnapshotRepo.vala"
		_tmp23_ = _tmp22_;
#line 77 "Core/SnapshotRepo.vala"
		_tmp24_ = g_strconcat (_ ("Free space"), _tmp23_, NULL);
#line 77 "Core/SnapshotRepo.vala"
		_tmp25_ = _tmp24_;
#line 77 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp25_);
#line 77 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp25_);
#line 77 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp23_);
#line 77 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp21_);
#line 788 "SnapshotRepo.c"
	}
#line 80 "Core/SnapshotRepo.vala"
	snapshot_repo_check_status (self);
#line 53 "Core/SnapshotRepo.vala"
	_g_object_unref0 (list);
#line 53 "Core/SnapshotRepo.vala"
	return self;
#line 796 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_new_from_path (const gchar* path,
                             GtkWindow* parent_win,
                             gboolean _btrfs_mode)
{
#line 53 "Core/SnapshotRepo.vala"
	return snapshot_repo_construct_from_path (TYPE_SNAPSHOT_REPO, path, parent_win, _btrfs_mode);
#line 806 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_construct_from_device (GType object_type,
                                     Device* dev,
                                     GtkWindow* parent_win,
                                     gboolean btrfs_repo)
{
	SnapshotRepo * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	Device* _tmp3_;
	GtkWindow* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeHashMap* _tmp7_;
#line 83 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (dev != NULL, NULL);
#line 83 "Core/SnapshotRepo.vala"
	self = (SnapshotRepo*) g_object_new (object_type, NULL);
#line 85 "Core/SnapshotRepo.vala"
	if (btrfs_repo) {
#line 85 "Core/SnapshotRepo.vala"
		_tmp0_ = "BTRFS";
#line 832 "SnapshotRepo.c"
	} else {
#line 85 "Core/SnapshotRepo.vala"
		_tmp0_ = "RSYNC";
#line 836 "SnapshotRepo.c"
	}
#line 85 "Core/SnapshotRepo.vala"
	_tmp1_ = g_strdup_printf ("SnapshotRepo: from_device(): %s", _tmp0_);
#line 85 "Core/SnapshotRepo.vala"
	_tmp2_ = _tmp1_;
#line 85 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_tmp2_);
#line 85 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp2_);
#line 87 "Core/SnapshotRepo.vala"
	_tmp3_ = _g_object_ref0 (dev);
#line 87 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->device);
#line 87 "Core/SnapshotRepo.vala"
	self->device = _tmp3_;
#line 89 "Core/SnapshotRepo.vala"
	_tmp4_ = _g_object_ref0 (parent_win);
#line 89 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 89 "Core/SnapshotRepo.vala"
	self->priv->parent_window = _tmp4_;
#line 90 "Core/SnapshotRepo.vala"
	self->btrfs_mode = btrfs_repo;
#line 92 "Core/SnapshotRepo.vala"
	_tmp5_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 92 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->snapshots);
#line 92 "Core/SnapshotRepo.vala"
	self->snapshots = _tmp5_;
#line 93 "Core/SnapshotRepo.vala"
	_tmp6_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 93 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->invalid_snapshots);
#line 93 "Core/SnapshotRepo.vala"
	self->invalid_snapshots = _tmp6_;
#line 94 "Core/SnapshotRepo.vala"
	_tmp7_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 94 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->mount_paths);
#line 94 "Core/SnapshotRepo.vala"
	self->mount_paths = _tmp7_;
#line 96 "Core/SnapshotRepo.vala"
	snapshot_repo_init_from_device (self);
#line 83 "Core/SnapshotRepo.vala"
	return self;
#line 882 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_new_from_device (Device* dev,
                               GtkWindow* parent_win,
                               gboolean btrfs_repo)
{
#line 83 "Core/SnapshotRepo.vala"
	return snapshot_repo_construct_from_device (TYPE_SNAPSHOT_REPO, dev, parent_win, btrfs_repo);
#line 892 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_construct_from_uuid (GType object_type,
                                   const gchar* uuid,
                                   GtkWindow* parent_win,
                                   gboolean btrfs_repo)
{
	SnapshotRepo * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	Device* _tmp5_;
	Device* _tmp6_;
	GtkWindow* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeHashMap* _tmp13_;
#line 99 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 99 "Core/SnapshotRepo.vala"
	self = (SnapshotRepo*) g_object_new (object_type, NULL);
#line 101 "Core/SnapshotRepo.vala"
	if (btrfs_repo) {
#line 101 "Core/SnapshotRepo.vala"
		_tmp0_ = "BTRFS";
#line 921 "SnapshotRepo.c"
	} else {
#line 101 "Core/SnapshotRepo.vala"
		_tmp0_ = "RSYNC";
#line 925 "SnapshotRepo.c"
	}
#line 101 "Core/SnapshotRepo.vala"
	_tmp1_ = g_strdup_printf ("SnapshotRepo: from_uuid(): %s", _tmp0_);
#line 101 "Core/SnapshotRepo.vala"
	_tmp2_ = _tmp1_;
#line 101 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_tmp2_);
#line 101 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp2_);
#line 102 "Core/SnapshotRepo.vala"
	_tmp3_ = g_strdup_printf ("uuid=%s", uuid);
#line 102 "Core/SnapshotRepo.vala"
	_tmp4_ = _tmp3_;
#line 102 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 102 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp4_);
#line 104 "Core/SnapshotRepo.vala"
	_tmp5_ = device_get_device_by_uuid (uuid);
#line 104 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->device);
#line 104 "Core/SnapshotRepo.vala"
	self->device = _tmp5_;
#line 105 "Core/SnapshotRepo.vala"
	_tmp6_ = self->device;
#line 105 "Core/SnapshotRepo.vala"
	if (_tmp6_ == NULL) {
#line 953 "SnapshotRepo.c"
		Device* _tmp7_;
		Device* _tmp8_;
		gchar* _tmp9_;
#line 106 "Core/SnapshotRepo.vala"
		_tmp7_ = device_new ();
#line 106 "Core/SnapshotRepo.vala"
		_g_object_unref0 (self->device);
#line 106 "Core/SnapshotRepo.vala"
		self->device = _tmp7_;
#line 107 "Core/SnapshotRepo.vala"
		_tmp8_ = self->device;
#line 107 "Core/SnapshotRepo.vala"
		_tmp9_ = g_strdup (uuid);
#line 107 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp8_->uuid);
#line 107 "Core/SnapshotRepo.vala"
		_tmp8_->uuid = _tmp9_;
#line 971 "SnapshotRepo.c"
	}
#line 111 "Core/SnapshotRepo.vala"
	_tmp10_ = _g_object_ref0 (parent_win);
#line 111 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 111 "Core/SnapshotRepo.vala"
	self->priv->parent_window = _tmp10_;
#line 112 "Core/SnapshotRepo.vala"
	self->btrfs_mode = btrfs_repo;
#line 114 "Core/SnapshotRepo.vala"
	_tmp11_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 114 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->snapshots);
#line 114 "Core/SnapshotRepo.vala"
	self->snapshots = _tmp11_;
#line 115 "Core/SnapshotRepo.vala"
	_tmp12_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 115 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->invalid_snapshots);
#line 115 "Core/SnapshotRepo.vala"
	self->invalid_snapshots = _tmp12_;
#line 116 "Core/SnapshotRepo.vala"
	_tmp13_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 116 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->mount_paths);
#line 116 "Core/SnapshotRepo.vala"
	self->mount_paths = _tmp13_;
#line 118 "Core/SnapshotRepo.vala"
	snapshot_repo_init_from_device (self);
#line 120 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: from_uuid(): exit");
#line 99 "Core/SnapshotRepo.vala"
	return self;
#line 1005 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_new_from_uuid (const gchar* uuid,
                             GtkWindow* parent_win,
                             gboolean btrfs_repo)
{
#line 99 "Core/SnapshotRepo.vala"
	return snapshot_repo_construct_from_uuid (TYPE_SNAPSHOT_REPO, uuid, parent_win, btrfs_repo);
#line 1015 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_construct_from_null (GType object_type)
{
	SnapshotRepo * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashMap* _tmp2_;
#line 123 "Core/SnapshotRepo.vala"
	self = (SnapshotRepo*) g_object_new (object_type, NULL);
#line 125 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: from_null()");
#line 126 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("device not set");
#line 128 "Core/SnapshotRepo.vala"
	_tmp0_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 128 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->snapshots);
#line 128 "Core/SnapshotRepo.vala"
	self->snapshots = _tmp0_;
#line 129 "Core/SnapshotRepo.vala"
	_tmp1_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 129 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->invalid_snapshots);
#line 129 "Core/SnapshotRepo.vala"
	self->invalid_snapshots = _tmp1_;
#line 130 "Core/SnapshotRepo.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 130 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->mount_paths);
#line 130 "Core/SnapshotRepo.vala"
	self->mount_paths = _tmp2_;
#line 132 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: from_null(): exit");
#line 123 "Core/SnapshotRepo.vala"
	return self;
#line 1053 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_new_from_null (void)
{
#line 123 "Core/SnapshotRepo.vala"
	return snapshot_repo_construct_from_null (TYPE_SNAPSHOT_REPO);
#line 1061 "SnapshotRepo.c"
}

static void
snapshot_repo_init_from_device (SnapshotRepo* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Device* _tmp2_;
	gboolean _tmp32_ = FALSE;
	Device* _tmp33_;
#line 135 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 137 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: init_from_device()");
#line 139 "Core/SnapshotRepo.vala"
	_tmp2_ = self->device;
#line 139 "Core/SnapshotRepo.vala"
	if (_tmp2_ != NULL) {
#line 1080 "SnapshotRepo.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 139 "Core/SnapshotRepo.vala"
		_tmp3_ = self->device;
#line 139 "Core/SnapshotRepo.vala"
		_tmp4_ = _tmp3_->uuid;
#line 139 "Core/SnapshotRepo.vala"
		_tmp5_ = strlen (_tmp4_);
#line 139 "Core/SnapshotRepo.vala"
		_tmp6_ = _tmp5_;
#line 139 "Core/SnapshotRepo.vala"
		_tmp1_ = _tmp6_ > 0;
#line 1095 "SnapshotRepo.c"
	} else {
#line 139 "Core/SnapshotRepo.vala"
		_tmp1_ = FALSE;
#line 1099 "SnapshotRepo.c"
	}
#line 139 "Core/SnapshotRepo.vala"
	if (_tmp1_) {
#line 1103 "SnapshotRepo.c"
		Device* _tmp7_;
		const gchar* _tmp8_;
		Device* _tmp9_;
		Device* _tmp10_;
#line 139 "Core/SnapshotRepo.vala"
		_tmp7_ = self->device;
#line 139 "Core/SnapshotRepo.vala"
		_tmp8_ = _tmp7_->uuid;
#line 139 "Core/SnapshotRepo.vala"
		_tmp9_ = device_get_device_by_uuid (_tmp8_);
#line 139 "Core/SnapshotRepo.vala"
		_tmp10_ = _tmp9_;
#line 139 "Core/SnapshotRepo.vala"
		_tmp0_ = _tmp10_ != NULL;
#line 139 "Core/SnapshotRepo.vala"
		_g_object_unref0 (_tmp10_);
#line 1120 "SnapshotRepo.c"
	} else {
#line 139 "Core/SnapshotRepo.vala"
		_tmp0_ = FALSE;
#line 1124 "SnapshotRepo.c"
	}
#line 139 "Core/SnapshotRepo.vala"
	if (_tmp0_) {
#line 1128 "SnapshotRepo.c"
		gboolean _tmp11_ = FALSE;
		Device* _tmp12_;
#line 141 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("");
#line 142 "Core/SnapshotRepo.vala"
		snapshot_repo_unlock_and_mount_devices (self);
#line 144 "Core/SnapshotRepo.vala"
		_tmp12_ = self->device;
#line 144 "Core/SnapshotRepo.vala"
		if (_tmp12_ != NULL) {
#line 1139 "SnapshotRepo.c"
			Device* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 144 "Core/SnapshotRepo.vala"
			_tmp13_ = self->device;
#line 144 "Core/SnapshotRepo.vala"
			_tmp14_ = _tmp13_->device;
#line 144 "Core/SnapshotRepo.vala"
			_tmp15_ = strlen (_tmp14_);
#line 144 "Core/SnapshotRepo.vala"
			_tmp16_ = _tmp15_;
#line 144 "Core/SnapshotRepo.vala"
			_tmp11_ = _tmp16_ > 0;
#line 1154 "SnapshotRepo.c"
		} else {
#line 144 "Core/SnapshotRepo.vala"
			_tmp11_ = FALSE;
#line 1158 "SnapshotRepo.c"
		}
#line 144 "Core/SnapshotRepo.vala"
		if (_tmp11_) {
#line 1162 "SnapshotRepo.c"
			Device* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			Device* _tmp23_;
			guint64 _tmp24_;
			guint64 _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
#line 146 "Core/SnapshotRepo.vala"
			_tmp17_ = self->device;
#line 146 "Core/SnapshotRepo.vala"
			_tmp18_ = _tmp17_->device;
#line 146 "Core/SnapshotRepo.vala"
			_tmp19_ = g_strdup_printf (": %s", _tmp18_);
#line 146 "Core/SnapshotRepo.vala"
			_tmp20_ = _tmp19_;
#line 146 "Core/SnapshotRepo.vala"
			_tmp21_ = g_strconcat (_ ("Selected snapshot device"), _tmp20_, NULL);
#line 146 "Core/SnapshotRepo.vala"
			_tmp22_ = _tmp21_;
#line 146 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug (_tmp22_);
#line 146 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp22_);
#line 146 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp20_);
#line 147 "Core/SnapshotRepo.vala"
			_tmp23_ = self->device;
#line 147 "Core/SnapshotRepo.vala"
			_tmp24_ = device_get_free_bytes (_tmp23_);
#line 147 "Core/SnapshotRepo.vala"
			_tmp25_ = _tmp24_;
#line 147 "Core/SnapshotRepo.vala"
			_tmp26_ = tee_jee_file_system_format_file_size (_tmp25_, FALSE, "", TRUE, 1);
#line 147 "Core/SnapshotRepo.vala"
			_tmp27_ = _tmp26_;
#line 147 "Core/SnapshotRepo.vala"
			_tmp28_ = g_strdup_printf (": %s", _tmp27_);
#line 147 "Core/SnapshotRepo.vala"
			_tmp29_ = _tmp28_;
#line 147 "Core/SnapshotRepo.vala"
			_tmp30_ = g_strconcat (_ ("Free space"), _tmp29_, NULL);
#line 147 "Core/SnapshotRepo.vala"
			_tmp31_ = _tmp30_;
#line 147 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug (_tmp31_);
#line 147 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp31_);
#line 147 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp29_);
#line 147 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp27_);
#line 1222 "SnapshotRepo.c"
		}
	}
#line 151 "Core/SnapshotRepo.vala"
	_tmp33_ = self->device;
#line 151 "Core/SnapshotRepo.vala"
	if (_tmp33_ != NULL) {
#line 1229 "SnapshotRepo.c"
		Device* _tmp34_;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
#line 151 "Core/SnapshotRepo.vala"
		_tmp34_ = self->device;
#line 151 "Core/SnapshotRepo.vala"
		_tmp35_ = _tmp34_->device;
#line 151 "Core/SnapshotRepo.vala"
		_tmp36_ = strlen (_tmp35_);
#line 151 "Core/SnapshotRepo.vala"
		_tmp37_ = _tmp36_;
#line 151 "Core/SnapshotRepo.vala"
		_tmp32_ = _tmp37_ > 0;
#line 1244 "SnapshotRepo.c"
	} else {
#line 151 "Core/SnapshotRepo.vala"
		_tmp32_ = FALSE;
#line 1248 "SnapshotRepo.c"
	}
#line 151 "Core/SnapshotRepo.vala"
	if (_tmp32_) {
#line 153 "Core/SnapshotRepo.vala"
		snapshot_repo_check_status (self);
#line 1254 "SnapshotRepo.c"
	}
#line 156 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: init_from_device(): exit");
#line 1258 "SnapshotRepo.c"
}

gboolean
snapshot_repo_unlock_and_mount_devices (SnapshotRepo* self)
{
	Device* _tmp0_;
	Device* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GeeHashMap* _tmp10_;
	GeeHashMap* _tmp11_;
	gboolean result = FALSE;
#line 180 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 182 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: unlock_and_mount_devices()");
#line 184 "Core/SnapshotRepo.vala"
	_tmp0_ = self->device;
#line 184 "Core/SnapshotRepo.vala"
	if (_tmp0_ == NULL) {
#line 185 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("device=null");
#line 1283 "SnapshotRepo.c"
	} else {
		Device* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 188 "Core/SnapshotRepo.vala"
		_tmp1_ = self->device;
#line 188 "Core/SnapshotRepo.vala"
		_tmp2_ = _tmp1_->device;
#line 188 "Core/SnapshotRepo.vala"
		_tmp3_ = g_strdup_printf ("device=%s", _tmp2_);
#line 188 "Core/SnapshotRepo.vala"
		_tmp4_ = _tmp3_;
#line 188 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp4_);
#line 188 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp4_);
#line 1301 "SnapshotRepo.c"
	}
#line 191 "Core/SnapshotRepo.vala"
	_tmp5_ = self->device;
#line 191 "Core/SnapshotRepo.vala"
	_tmp6_ = snapshot_repo_unlock_and_mount_device (self, _tmp5_, "/run/timeshift/backup");
#line 191 "Core/SnapshotRepo.vala"
	_g_free0 (self->mount_path);
#line 191 "Core/SnapshotRepo.vala"
	self->mount_path = _tmp6_;
#line 193 "Core/SnapshotRepo.vala"
	_tmp7_ = self->mount_path;
#line 193 "Core/SnapshotRepo.vala"
	_tmp8_ = strlen (_tmp7_);
#line 193 "Core/SnapshotRepo.vala"
	_tmp9_ = _tmp8_;
#line 193 "Core/SnapshotRepo.vala"
	if (_tmp9_ == 0) {
#line 194 "Core/SnapshotRepo.vala"
		result = FALSE;
#line 194 "Core/SnapshotRepo.vala"
		return result;
#line 1323 "SnapshotRepo.c"
	}
#line 198 "Core/SnapshotRepo.vala"
	_tmp10_ = self->mount_paths;
#line 198 "Core/SnapshotRepo.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, "@", "");
#line 199 "Core/SnapshotRepo.vala"
	_tmp11_ = self->mount_paths;
#line 199 "Core/SnapshotRepo.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, "@home", "");
#line 201 "Core/SnapshotRepo.vala"
	if (self->btrfs_mode) {
#line 1335 "SnapshotRepo.c"
		GeeHashMap* _tmp12_;
		const gchar* _tmp13_;
		GeeHashMap* _tmp14_;
		const gchar* _tmp15_;
		Device* _tmp16_;
		Device* _tmp17_;
		GeeHashMap* repo_subvolumes = NULL;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GtkWindow* _tmp21_;
		GeeHashMap* _tmp22_;
		GeeHashMap* _tmp23_;
		GeeHashMap* _tmp24_;
#line 203 "Core/SnapshotRepo.vala"
		_tmp12_ = self->mount_paths;
#line 203 "Core/SnapshotRepo.vala"
		_tmp13_ = self->mount_path;
#line 203 "Core/SnapshotRepo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, "@", _tmp13_);
#line 204 "Core/SnapshotRepo.vala"
		_tmp14_ = self->mount_paths;
#line 204 "Core/SnapshotRepo.vala"
		_tmp15_ = self->mount_path;
#line 204 "Core/SnapshotRepo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, "@home", _tmp15_);
#line 205 "Core/SnapshotRepo.vala"
		_tmp16_ = self->device;
#line 205 "Core/SnapshotRepo.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 205 "Core/SnapshotRepo.vala"
		_g_object_unref0 (self->device_home);
#line 205 "Core/SnapshotRepo.vala"
		self->device_home = _tmp17_;
#line 209 "Core/SnapshotRepo.vala"
		_tmp18_ = self->mount_path;
#line 209 "Core/SnapshotRepo.vala"
		_tmp19_ = tee_jee_file_system_path_combine (_tmp18_, "@");
#line 209 "Core/SnapshotRepo.vala"
		_tmp20_ = _tmp19_;
#line 209 "Core/SnapshotRepo.vala"
		_tmp21_ = self->priv->parent_window;
#line 209 "Core/SnapshotRepo.vala"
		_tmp22_ = subvolume_detect_subvolumes_for_system_by_path (_tmp20_, self, _tmp21_);
#line 209 "Core/SnapshotRepo.vala"
		_tmp23_ = _tmp22_;
#line 209 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp20_);
#line 209 "Core/SnapshotRepo.vala"
		repo_subvolumes = _tmp23_;
#line 211 "Core/SnapshotRepo.vala"
		_tmp24_ = repo_subvolumes;
#line 211 "Core/SnapshotRepo.vala"
		if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp24_, "@home")) {
#line 1390 "SnapshotRepo.c"
			Subvolume* subvol = NULL;
			GeeHashMap* _tmp25_;
			gpointer _tmp26_;
			Subvolume* _tmp27_;
			const gchar* _tmp28_;
			Device* _tmp29_;
			const gchar* _tmp30_;
#line 213 "Core/SnapshotRepo.vala"
			_tmp25_ = repo_subvolumes;
#line 213 "Core/SnapshotRepo.vala"
			_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp25_, "@home");
#line 213 "Core/SnapshotRepo.vala"
			subvol = (Subvolume*) _tmp26_;
#line 215 "Core/SnapshotRepo.vala"
			_tmp27_ = subvol;
#line 215 "Core/SnapshotRepo.vala"
			_tmp28_ = _tmp27_->device_uuid;
#line 215 "Core/SnapshotRepo.vala"
			_tmp29_ = self->device;
#line 215 "Core/SnapshotRepo.vala"
			_tmp30_ = _tmp29_->uuid;
#line 215 "Core/SnapshotRepo.vala"
			if (g_strcmp0 (_tmp28_, _tmp30_) != 0) {
#line 1414 "SnapshotRepo.c"
				Subvolume* _tmp31_;
				Device* _tmp32_;
				GeeHashMap* _tmp33_;
				Device* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				GeeHashMap* _tmp37_;
				gpointer _tmp38_;
				gchar* _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				gboolean _tmp42_;
#line 218 "Core/SnapshotRepo.vala"
				_tmp31_ = subvol;
#line 218 "Core/SnapshotRepo.vala"
				_tmp32_ = subvolume_get_device (_tmp31_);
#line 218 "Core/SnapshotRepo.vala"
				_g_object_unref0 (self->device_home);
#line 218 "Core/SnapshotRepo.vala"
				self->device_home = _tmp32_;
#line 220 "Core/SnapshotRepo.vala"
				_tmp33_ = self->mount_paths;
#line 220 "Core/SnapshotRepo.vala"
				_tmp34_ = self->device_home;
#line 220 "Core/SnapshotRepo.vala"
				_tmp35_ = snapshot_repo_unlock_and_mount_device (self, _tmp34_, "/run/timeshift/backup-home");
#line 220 "Core/SnapshotRepo.vala"
				_tmp36_ = _tmp35_;
#line 220 "Core/SnapshotRepo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp33_, "@home", _tmp36_);
#line 220 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp36_);
#line 222 "Core/SnapshotRepo.vala"
				_tmp37_ = self->mount_paths;
#line 222 "Core/SnapshotRepo.vala"
				_tmp38_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp37_, "@home");
#line 222 "Core/SnapshotRepo.vala"
				_tmp39_ = (gchar*) _tmp38_;
#line 222 "Core/SnapshotRepo.vala"
				_tmp40_ = strlen (_tmp39_);
#line 222 "Core/SnapshotRepo.vala"
				_tmp41_ = _tmp40_;
#line 222 "Core/SnapshotRepo.vala"
				_tmp42_ = _tmp41_ == 0;
#line 222 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp39_);
#line 222 "Core/SnapshotRepo.vala"
				if (_tmp42_) {
#line 223 "Core/SnapshotRepo.vala"
					result = FALSE;
#line 223 "Core/SnapshotRepo.vala"
					_g_object_unref0 (subvol);
#line 223 "Core/SnapshotRepo.vala"
					_g_object_unref0 (repo_subvolumes);
#line 223 "Core/SnapshotRepo.vala"
					return result;
#line 1471 "SnapshotRepo.c"
				}
			}
#line 211 "Core/SnapshotRepo.vala"
			_g_object_unref0 (subvol);
#line 1476 "SnapshotRepo.c"
		}
#line 201 "Core/SnapshotRepo.vala"
		_g_object_unref0 (repo_subvolumes);
#line 1480 "SnapshotRepo.c"
	}
#line 229 "Core/SnapshotRepo.vala"
	snapshot_repo_load_snapshots (self);
#line 231 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: unlock_and_mount_device(): exit");
#line 233 "Core/SnapshotRepo.vala"
	result = TRUE;
#line 233 "Core/SnapshotRepo.vala"
	return result;
#line 1490 "SnapshotRepo.c"
}

gchar*
snapshot_repo_unlock_and_mount_device (SnapshotRepo* self,
                                       Device* device_to_mount,
                                       const gchar* path_to_mount)
{
	Device* dev = NULL;
	Device* _tmp0_;
	Device* _tmp1_;
	Device* _tmp6_;
	gboolean ok = FALSE;
	Device* _tmp13_;
	const gchar* _tmp14_;
	gchar* result = NULL;
#line 236 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (device_to_mount != NULL, NULL);
#line 236 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (path_to_mount != NULL, NULL);
#line 240 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: unlock_and_mount_device()");
#line 242 "Core/SnapshotRepo.vala"
	_tmp0_ = _g_object_ref0 (device_to_mount);
#line 242 "Core/SnapshotRepo.vala"
	dev = _tmp0_;
#line 244 "Core/SnapshotRepo.vala"
	_tmp1_ = dev;
#line 244 "Core/SnapshotRepo.vala"
	if (_tmp1_ == NULL) {
#line 245 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("device=null");
#line 1524 "SnapshotRepo.c"
	} else {
		Device* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 248 "Core/SnapshotRepo.vala"
		_tmp2_ = dev;
#line 248 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_->device;
#line 248 "Core/SnapshotRepo.vala"
		_tmp4_ = g_strdup_printf ("device=%s", _tmp3_);
#line 248 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 248 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp5_);
#line 248 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp5_);
#line 1542 "SnapshotRepo.c"
	}
#line 252 "Core/SnapshotRepo.vala"
	_tmp6_ = dev;
#line 252 "Core/SnapshotRepo.vala"
	if (device_is_encrypted_partition (_tmp6_)) {
#line 1548 "SnapshotRepo.c"
		Device* _tmp7_;
		Device* _tmp8_;
		Device* _tmp9_;
		Device* _tmp10_;
		Device* _tmp11_;
#line 254 "Core/SnapshotRepo.vala"
		_tmp7_ = dev;
#line 254 "Core/SnapshotRepo.vala"
		_tmp8_ = snapshot_repo_unlock_encrypted_device (self, _tmp7_);
#line 254 "Core/SnapshotRepo.vala"
		_g_object_unref0 (dev);
#line 254 "Core/SnapshotRepo.vala"
		dev = _tmp8_;
#line 255 "Core/SnapshotRepo.vala"
		_tmp9_ = dev;
#line 255 "Core/SnapshotRepo.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 255 "Core/SnapshotRepo.vala"
		_g_object_unref0 (self->device);
#line 255 "Core/SnapshotRepo.vala"
		self->device = _tmp10_;
#line 257 "Core/SnapshotRepo.vala"
		_tmp11_ = dev;
#line 257 "Core/SnapshotRepo.vala"
		if (_tmp11_ == NULL) {
#line 1574 "SnapshotRepo.c"
			gchar* _tmp12_;
#line 258 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug ("device is null");
#line 259 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug ("SnapshotRepo: unlock_and_mount_device(): exit");
#line 260 "Core/SnapshotRepo.vala"
			_tmp12_ = g_strdup ("");
#line 260 "Core/SnapshotRepo.vala"
			result = _tmp12_;
#line 260 "Core/SnapshotRepo.vala"
			_g_object_unref0 (dev);
#line 260 "Core/SnapshotRepo.vala"
			return result;
#line 1588 "SnapshotRepo.c"
		}
	}
#line 265 "Core/SnapshotRepo.vala"
	_tmp13_ = dev;
#line 265 "Core/SnapshotRepo.vala"
	_tmp14_ = _tmp13_->uuid;
#line 265 "Core/SnapshotRepo.vala"
	ok = device_mount (_tmp14_, path_to_mount, "", FALSE);
#line 267 "Core/SnapshotRepo.vala"
	if (ok) {
#line 1599 "SnapshotRepo.c"
		gchar* _tmp15_;
#line 268 "Core/SnapshotRepo.vala"
		_tmp15_ = g_strdup (path_to_mount);
#line 268 "Core/SnapshotRepo.vala"
		result = _tmp15_;
#line 268 "Core/SnapshotRepo.vala"
		_g_object_unref0 (dev);
#line 268 "Core/SnapshotRepo.vala"
		return result;
#line 1609 "SnapshotRepo.c"
	} else {
		gchar* _tmp16_;
#line 271 "Core/SnapshotRepo.vala"
		_tmp16_ = g_strdup ("");
#line 271 "Core/SnapshotRepo.vala"
		result = _tmp16_;
#line 271 "Core/SnapshotRepo.vala"
		_g_object_unref0 (dev);
#line 271 "Core/SnapshotRepo.vala"
		return result;
#line 1620 "SnapshotRepo.c"
	}
}

Device*
snapshot_repo_unlock_encrypted_device (SnapshotRepo* self,
                                       Device* luks_device)
{
	gchar* msg_out = NULL;
	gchar* msg_err = NULL;
	Device* luks_unlocked = NULL;
	GtkWindow* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	Device* _tmp6_;
	Device* result = NULL;
#line 275 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 275 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (luks_device != NULL, NULL);
#line 277 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: unlock_encrypted_device()");
#line 279 "Core/SnapshotRepo.vala"
	if (luks_device == NULL) {
#line 280 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("luks_device=null");
#line 281 "Core/SnapshotRepo.vala"
		result = NULL;
#line 281 "Core/SnapshotRepo.vala"
		return result;
#line 1650 "SnapshotRepo.c"
	} else {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 284 "Core/SnapshotRepo.vala"
		_tmp0_ = luks_device->device;
#line 284 "Core/SnapshotRepo.vala"
		_tmp1_ = g_strdup_printf ("luks_device=%s", _tmp0_);
#line 284 "Core/SnapshotRepo.vala"
		_tmp2_ = _tmp1_;
#line 284 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 284 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp2_);
#line 1665 "SnapshotRepo.c"
	}
#line 288 "Core/SnapshotRepo.vala"
	_tmp3_ = self->priv->parent_window;
#line 288 "Core/SnapshotRepo.vala"
	_tmp6_ = device_luks_unlock (luks_device, "", "", _tmp3_, &_tmp4_, &_tmp5_);
#line 288 "Core/SnapshotRepo.vala"
	_g_free0 (msg_out);
#line 288 "Core/SnapshotRepo.vala"
	msg_out = _tmp4_;
#line 288 "Core/SnapshotRepo.vala"
	_g_free0 (msg_err);
#line 288 "Core/SnapshotRepo.vala"
	msg_err = _tmp5_;
#line 288 "Core/SnapshotRepo.vala"
	luks_unlocked = _tmp6_;
#line 291 "Core/SnapshotRepo.vala"
	result = luks_unlocked;
#line 291 "Core/SnapshotRepo.vala"
	_g_free0 (msg_err);
#line 291 "Core/SnapshotRepo.vala"
	_g_free0 (msg_out);
#line 291 "Core/SnapshotRepo.vala"
	return result;
#line 1689 "SnapshotRepo.c"
}

static gint
__lambda8_ (SnapshotRepo* self,
            Snapshot* a,
            Snapshot* b)
{
	Snapshot* t1 = NULL;
	Snapshot* _tmp0_;
	Snapshot* t2 = NULL;
	Snapshot* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gint result = 0;
#line 334 "Core/SnapshotRepo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_SNAPSHOT, Snapshot));
#line 334 "Core/SnapshotRepo.vala"
	t1 = _tmp0_;
#line 335 "Core/SnapshotRepo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_SNAPSHOT, Snapshot));
#line 335 "Core/SnapshotRepo.vala"
	t2 = _tmp1_;
#line 336 "Core/SnapshotRepo.vala"
	_tmp2_ = t1->date;
#line 336 "Core/SnapshotRepo.vala"
	_tmp3_ = t2->date;
#line 336 "Core/SnapshotRepo.vala"
	result = g_date_time_compare (_tmp2_, _tmp3_);
#line 336 "Core/SnapshotRepo.vala"
	_g_object_unref0 (t2);
#line 336 "Core/SnapshotRepo.vala"
	_g_object_unref0 (t1);
#line 336 "Core/SnapshotRepo.vala"
	return result;
#line 1724 "SnapshotRepo.c"
}

static gint
___lambda8__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda8_ ((SnapshotRepo*) self, (Snapshot*) a, (Snapshot*) b);
#line 333 "Core/SnapshotRepo.vala"
	return result;
#line 1736 "SnapshotRepo.c"
}

gboolean
snapshot_repo_load_snapshots (SnapshotRepo* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Device* _tmp3_;
	GeeArrayList* _tmp43_;
	GDateTime* dt_boot = NULL;
	GDateTime* _tmp44_;
	GDateTime* _tmp45_;
	GDateTime* _tmp46_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	GeeArrayList* _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 294 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 296 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: load_snapshots()");
#line 298 "Core/SnapshotRepo.vala"
	_tmp0_ = self->snapshots;
#line 298 "Core/SnapshotRepo.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 299 "Core/SnapshotRepo.vala"
	_tmp1_ = self->invalid_snapshots;
#line 299 "Core/SnapshotRepo.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 301 "Core/SnapshotRepo.vala"
	_tmp3_ = self->device;
#line 301 "Core/SnapshotRepo.vala"
	if (_tmp3_ == NULL) {
#line 301 "Core/SnapshotRepo.vala"
		_tmp2_ = TRUE;
#line 1779 "SnapshotRepo.c"
	} else {
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 301 "Core/SnapshotRepo.vala"
		_tmp4_ = snapshot_repo_get_snapshots_path (self);
#line 301 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 301 "Core/SnapshotRepo.vala"
		_tmp6_ = _tmp5_;
#line 301 "Core/SnapshotRepo.vala"
		_tmp2_ = !tee_jee_file_system_dir_exists (_tmp6_);
#line 301 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp6_);
#line 1794 "SnapshotRepo.c"
	}
#line 301 "Core/SnapshotRepo.vala"
	if (_tmp2_) {
#line 302 "Core/SnapshotRepo.vala"
		result = FALSE;
#line 302 "Core/SnapshotRepo.vala"
		return result;
#line 1802 "SnapshotRepo.c"
	}
	{
		GFile* dir = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp12_;
		GFileEnumerator* _tmp13_;
		GFileInfo* info = NULL;
		GFileEnumerator* _tmp14_;
		GFileInfo* _tmp15_;
#line 306 "Core/SnapshotRepo.vala"
		_tmp7_ = snapshot_repo_get_snapshots_path (self);
#line 306 "Core/SnapshotRepo.vala"
		_tmp8_ = _tmp7_;
#line 306 "Core/SnapshotRepo.vala"
		_tmp9_ = _tmp8_;
#line 306 "Core/SnapshotRepo.vala"
		_tmp10_ = g_file_new_for_path (_tmp9_);
#line 306 "Core/SnapshotRepo.vala"
		_tmp11_ = _tmp10_;
#line 306 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp9_);
#line 306 "Core/SnapshotRepo.vala"
		dir = _tmp11_;
#line 307 "Core/SnapshotRepo.vala"
		_tmp12_ = dir;
#line 307 "Core/SnapshotRepo.vala"
		_tmp13_ = g_file_enumerate_children (_tmp12_, "*", 0, NULL, &_inner_error0_);
#line 307 "Core/SnapshotRepo.vala"
		enumerator = _tmp13_;
#line 307 "Core/SnapshotRepo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "Core/SnapshotRepo.vala"
			_g_object_unref0 (dir);
#line 1841 "SnapshotRepo.c"
			goto __catch0_g_error;
		}
#line 309 "Core/SnapshotRepo.vala"
		_tmp14_ = enumerator;
#line 309 "Core/SnapshotRepo.vala"
		_tmp15_ = g_file_enumerator_next_file (_tmp14_, NULL, &_inner_error0_);
#line 309 "Core/SnapshotRepo.vala"
		info = _tmp15_;
#line 309 "Core/SnapshotRepo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "Core/SnapshotRepo.vala"
			_g_object_unref0 (enumerator);
#line 309 "Core/SnapshotRepo.vala"
			_g_object_unref0 (dir);
#line 1856 "SnapshotRepo.c"
			goto __catch0_g_error;
		}
#line 310 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 1861 "SnapshotRepo.c"
			GFileInfo* _tmp16_;
			GFileInfo* _tmp17_;
			GFileInfo* _tmp36_ = NULL;
			GFileEnumerator* _tmp37_;
			GFileInfo* _tmp38_;
			GFileInfo* _tmp39_;
#line 310 "Core/SnapshotRepo.vala"
			_tmp16_ = info;
#line 310 "Core/SnapshotRepo.vala"
			if (!(_tmp16_ != NULL)) {
#line 310 "Core/SnapshotRepo.vala"
				break;
#line 1874 "SnapshotRepo.c"
			}
#line 311 "Core/SnapshotRepo.vala"
			_tmp17_ = info;
#line 311 "Core/SnapshotRepo.vala"
			if (g_file_info_get_file_type (_tmp17_) == G_FILE_TYPE_DIRECTORY) {
#line 1880 "SnapshotRepo.c"
				GFileInfo* _tmp18_;
				const gchar* _tmp19_;
#line 312 "Core/SnapshotRepo.vala"
				_tmp18_ = info;
#line 312 "Core/SnapshotRepo.vala"
				_tmp19_ = g_file_info_get_name (_tmp18_);
#line 312 "Core/SnapshotRepo.vala"
				if (g_strcmp0 (_tmp19_, ".sync") != 0) {
#line 1889 "SnapshotRepo.c"
					Snapshot* bak = NULL;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					GFileInfo* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					Snapshot* _tmp29_;
					Snapshot* _tmp30_;
					Snapshot* _tmp31_;
#line 316 "Core/SnapshotRepo.vala"
					_tmp20_ = snapshot_repo_get_snapshots_path (self);
#line 316 "Core/SnapshotRepo.vala"
					_tmp21_ = _tmp20_;
#line 316 "Core/SnapshotRepo.vala"
					_tmp22_ = _tmp21_;
#line 316 "Core/SnapshotRepo.vala"
					_tmp23_ = g_strconcat (_tmp22_, "/", NULL);
#line 316 "Core/SnapshotRepo.vala"
					_tmp24_ = _tmp23_;
#line 316 "Core/SnapshotRepo.vala"
					_tmp25_ = info;
#line 316 "Core/SnapshotRepo.vala"
					_tmp26_ = g_file_info_get_name (_tmp25_);
#line 316 "Core/SnapshotRepo.vala"
					_tmp27_ = g_strconcat (_tmp24_, _tmp26_, NULL);
#line 316 "Core/SnapshotRepo.vala"
					_tmp28_ = _tmp27_;
#line 316 "Core/SnapshotRepo.vala"
					_tmp29_ = snapshot_new (_tmp28_, self->btrfs_mode, self);
#line 316 "Core/SnapshotRepo.vala"
					_tmp30_ = _tmp29_;
#line 316 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp28_);
#line 316 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp24_);
#line 316 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp22_);
#line 316 "Core/SnapshotRepo.vala"
					bak = _tmp30_;
#line 317 "Core/SnapshotRepo.vala"
					_tmp31_ = bak;
#line 317 "Core/SnapshotRepo.vala"
					if (_tmp31_->valid) {
#line 1937 "SnapshotRepo.c"
						GeeArrayList* _tmp32_;
						Snapshot* _tmp33_;
#line 318 "Core/SnapshotRepo.vala"
						_tmp32_ = self->snapshots;
#line 318 "Core/SnapshotRepo.vala"
						_tmp33_ = bak;
#line 318 "Core/SnapshotRepo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 1946 "SnapshotRepo.c"
					} else {
						GeeArrayList* _tmp34_;
						Snapshot* _tmp35_;
#line 321 "Core/SnapshotRepo.vala"
						_tmp34_ = self->invalid_snapshots;
#line 321 "Core/SnapshotRepo.vala"
						_tmp35_ = bak;
#line 321 "Core/SnapshotRepo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
#line 1956 "SnapshotRepo.c"
					}
#line 312 "Core/SnapshotRepo.vala"
					_g_object_unref0 (bak);
#line 1960 "SnapshotRepo.c"
				}
			}
#line 325 "Core/SnapshotRepo.vala"
			_tmp37_ = enumerator;
#line 325 "Core/SnapshotRepo.vala"
			_tmp38_ = g_file_enumerator_next_file (_tmp37_, NULL, &_inner_error0_);
#line 325 "Core/SnapshotRepo.vala"
			_tmp36_ = _tmp38_;
#line 325 "Core/SnapshotRepo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "Core/SnapshotRepo.vala"
				_g_object_unref0 (info);
#line 325 "Core/SnapshotRepo.vala"
				_g_object_unref0 (enumerator);
#line 325 "Core/SnapshotRepo.vala"
				_g_object_unref0 (dir);
#line 1977 "SnapshotRepo.c"
				goto __catch0_g_error;
			}
#line 325 "Core/SnapshotRepo.vala"
			_tmp39_ = _tmp36_;
#line 325 "Core/SnapshotRepo.vala"
			_tmp36_ = NULL;
#line 325 "Core/SnapshotRepo.vala"
			_g_object_unref0 (info);
#line 325 "Core/SnapshotRepo.vala"
			info = _tmp39_;
#line 310 "Core/SnapshotRepo.vala"
			_g_object_unref0 (_tmp36_);
#line 1990 "SnapshotRepo.c"
		}
#line 305 "Core/SnapshotRepo.vala"
		_g_object_unref0 (info);
#line 305 "Core/SnapshotRepo.vala"
		_g_object_unref0 (enumerator);
#line 305 "Core/SnapshotRepo.vala"
		_g_object_unref0 (dir);
#line 1998 "SnapshotRepo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp40_;
		const gchar* _tmp41_;
#line 305 "Core/SnapshotRepo.vala"
		e = _inner_error0_;
#line 305 "Core/SnapshotRepo.vala"
		_inner_error0_ = NULL;
#line 329 "Core/SnapshotRepo.vala"
		_tmp40_ = e;
#line 329 "Core/SnapshotRepo.vala"
		_tmp41_ = _tmp40_->message;
#line 329 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_error (_tmp41_, FALSE, FALSE);
#line 330 "Core/SnapshotRepo.vala"
		result = FALSE;
#line 330 "Core/SnapshotRepo.vala"
		_g_error_free0 (e);
#line 330 "Core/SnapshotRepo.vala"
		return result;
#line 2022 "SnapshotRepo.c"
	}
	__finally0:
#line 305 "Core/SnapshotRepo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2027 "SnapshotRepo.c"
		gboolean _tmp42_ = FALSE;
#line 305 "Core/SnapshotRepo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 305 "Core/SnapshotRepo.vala"
		g_clear_error (&_inner_error0_);
#line 305 "Core/SnapshotRepo.vala"
		return _tmp42_;
#line 2035 "SnapshotRepo.c"
	}
#line 333 "Core/SnapshotRepo.vala"
	_tmp43_ = self->snapshots;
#line 333 "Core/SnapshotRepo.vala"
	gee_list_sort ((GeeList*) _tmp43_, ___lambda8__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 341 "Core/SnapshotRepo.vala"
	_tmp44_ = g_date_time_new_now_local ();
#line 341 "Core/SnapshotRepo.vala"
	dt_boot = _tmp44_;
#line 342 "Core/SnapshotRepo.vala"
	_tmp45_ = dt_boot;
#line 342 "Core/SnapshotRepo.vala"
	_tmp46_ = g_date_time_add_seconds (_tmp45_, (-1.0) * tee_jee_system_get_system_uptime_seconds ());
#line 342 "Core/SnapshotRepo.vala"
	_g_date_time_unref0 (dt_boot);
#line 342 "Core/SnapshotRepo.vala"
	dt_boot = _tmp46_;
#line 2053 "SnapshotRepo.c"
	{
		GeeArrayList* _bak_list = NULL;
		GeeArrayList* _tmp47_;
		gint _bak_size = 0;
		GeeArrayList* _tmp48_;
		gint _tmp49_;
		gint _tmp50_;
		gint _bak_index = 0;
#line 343 "Core/SnapshotRepo.vala"
		_tmp47_ = self->snapshots;
#line 343 "Core/SnapshotRepo.vala"
		_bak_list = _tmp47_;
#line 343 "Core/SnapshotRepo.vala"
		_tmp48_ = _bak_list;
#line 343 "Core/SnapshotRepo.vala"
		_tmp49_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp48_);
#line 343 "Core/SnapshotRepo.vala"
		_tmp50_ = _tmp49_;
#line 343 "Core/SnapshotRepo.vala"
		_bak_size = _tmp50_;
#line 343 "Core/SnapshotRepo.vala"
		_bak_index = -1;
#line 343 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 2078 "SnapshotRepo.c"
			gint _tmp51_;
			gint _tmp52_;
			Snapshot* bak = NULL;
			GeeArrayList* _tmp53_;
			gpointer _tmp54_;
			Snapshot* _tmp55_;
#line 343 "Core/SnapshotRepo.vala"
			_bak_index = _bak_index + 1;
#line 343 "Core/SnapshotRepo.vala"
			_tmp51_ = _bak_index;
#line 343 "Core/SnapshotRepo.vala"
			_tmp52_ = _bak_size;
#line 343 "Core/SnapshotRepo.vala"
			if (!(_tmp51_ < _tmp52_)) {
#line 343 "Core/SnapshotRepo.vala"
				break;
#line 2095 "SnapshotRepo.c"
			}
#line 343 "Core/SnapshotRepo.vala"
			_tmp53_ = _bak_list;
#line 343 "Core/SnapshotRepo.vala"
			_tmp54_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _bak_index);
#line 343 "Core/SnapshotRepo.vala"
			bak = (Snapshot*) _tmp54_;
#line 344 "Core/SnapshotRepo.vala"
			_tmp55_ = bak;
#line 344 "Core/SnapshotRepo.vala"
			if (_tmp55_->live) {
#line 2107 "SnapshotRepo.c"
				gboolean _tmp56_ = FALSE;
				Main* _tmp57_;
				Device* _tmp58_;
#line 345 "Core/SnapshotRepo.vala"
				_tmp57_ = App;
#line 345 "Core/SnapshotRepo.vala"
				_tmp58_ = _tmp57_->sys_root;
#line 345 "Core/SnapshotRepo.vala"
				if (_tmp58_ == NULL) {
#line 345 "Core/SnapshotRepo.vala"
					_tmp56_ = TRUE;
#line 2119 "SnapshotRepo.c"
				} else {
					Main* _tmp59_;
					Device* _tmp60_;
					const gchar* _tmp61_;
					Snapshot* _tmp62_;
					const gchar* _tmp63_;
#line 345 "Core/SnapshotRepo.vala"
					_tmp59_ = App;
#line 345 "Core/SnapshotRepo.vala"
					_tmp60_ = _tmp59_->sys_root;
#line 345 "Core/SnapshotRepo.vala"
					_tmp61_ = _tmp60_->uuid;
#line 345 "Core/SnapshotRepo.vala"
					_tmp62_ = bak;
#line 345 "Core/SnapshotRepo.vala"
					_tmp63_ = _tmp62_->sys_uuid;
#line 345 "Core/SnapshotRepo.vala"
					_tmp56_ = g_strcmp0 (_tmp61_, _tmp63_) != 0;
#line 2138 "SnapshotRepo.c"
				}
#line 345 "Core/SnapshotRepo.vala"
				if (_tmp56_) {
#line 2142 "SnapshotRepo.c"
					Snapshot* _tmp64_;
					Snapshot* _tmp65_;
#line 347 "Core/SnapshotRepo.vala"
					_tmp64_ = bak;
#line 347 "Core/SnapshotRepo.vala"
					_tmp64_->live = FALSE;
#line 348 "Core/SnapshotRepo.vala"
					_tmp65_ = bak;
#line 348 "Core/SnapshotRepo.vala"
					snapshot_update_control_file (_tmp65_);
#line 2153 "SnapshotRepo.c"
				} else {
					Snapshot* _tmp66_;
					GDateTime* _tmp67_;
					GDateTime* _tmp68_;
#line 351 "Core/SnapshotRepo.vala"
					_tmp66_ = bak;
#line 351 "Core/SnapshotRepo.vala"
					_tmp67_ = _tmp66_->date;
#line 351 "Core/SnapshotRepo.vala"
					_tmp68_ = dt_boot;
#line 351 "Core/SnapshotRepo.vala"
					if (g_date_time_difference (_tmp67_, _tmp68_) < ((GTimeSpan) 0)) {
#line 2166 "SnapshotRepo.c"
						Snapshot* _tmp69_;
						Snapshot* _tmp70_;
#line 353 "Core/SnapshotRepo.vala"
						_tmp69_ = bak;
#line 353 "Core/SnapshotRepo.vala"
						_tmp69_->live = FALSE;
#line 354 "Core/SnapshotRepo.vala"
						_tmp70_ = bak;
#line 354 "Core/SnapshotRepo.vala"
						snapshot_update_control_file (_tmp70_);
#line 2177 "SnapshotRepo.c"
					} else {
					}
				}
			}
#line 343 "Core/SnapshotRepo.vala"
			_g_object_unref0 (bak);
#line 2184 "SnapshotRepo.c"
		}
	}
#line 363 "Core/SnapshotRepo.vala"
	if (self->btrfs_mode) {
#line 2189 "SnapshotRepo.c"
		Main* _tmp71_;
#line 364 "Core/SnapshotRepo.vala"
		_tmp71_ = App;
#line 364 "Core/SnapshotRepo.vala"
		main_query_subvolume_info (_tmp71_, self);
#line 2195 "SnapshotRepo.c"
	}
#line 367 "Core/SnapshotRepo.vala"
	_tmp72_ = snapshot_repo_get_snapshots_path (self);
#line 367 "Core/SnapshotRepo.vala"
	_tmp73_ = _tmp72_;
#line 367 "Core/SnapshotRepo.vala"
	_tmp74_ = _tmp73_;
#line 367 "Core/SnapshotRepo.vala"
	_tmp75_ = self->snapshots;
#line 367 "Core/SnapshotRepo.vala"
	_tmp76_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp75_);
#line 367 "Core/SnapshotRepo.vala"
	_tmp77_ = _tmp76_;
#line 367 "Core/SnapshotRepo.vala"
	_tmp78_ = g_strdup_printf ("loading snapshots from '%s': %d found", _tmp74_, _tmp77_);
#line 367 "Core/SnapshotRepo.vala"
	_tmp79_ = _tmp78_;
#line 367 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_tmp79_);
#line 367 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp79_);
#line 367 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp74_);
#line 369 "Core/SnapshotRepo.vala"
	result = TRUE;
#line 369 "Core/SnapshotRepo.vala"
	_g_date_time_unref0 (dt_boot);
#line 369 "Core/SnapshotRepo.vala"
	return result;
#line 2225 "SnapshotRepo.c"
}

static gint
__lambda9_ (SnapshotRepo* self,
            Snapshot* a,
            Snapshot* b)
{
	Snapshot* t1 = NULL;
	Snapshot* _tmp0_;
	Snapshot* t2 = NULL;
	Snapshot* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gint result = 0;
#line 384 "Core/SnapshotRepo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_SNAPSHOT, Snapshot));
#line 384 "Core/SnapshotRepo.vala"
	t1 = _tmp0_;
#line 385 "Core/SnapshotRepo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_SNAPSHOT, Snapshot));
#line 385 "Core/SnapshotRepo.vala"
	t2 = _tmp1_;
#line 386 "Core/SnapshotRepo.vala"
	_tmp2_ = t1->date;
#line 386 "Core/SnapshotRepo.vala"
	_tmp3_ = t2->date;
#line 386 "Core/SnapshotRepo.vala"
	result = g_date_time_compare (_tmp2_, _tmp3_);
#line 386 "Core/SnapshotRepo.vala"
	_g_object_unref0 (t2);
#line 386 "Core/SnapshotRepo.vala"
	_g_object_unref0 (t1);
#line 386 "Core/SnapshotRepo.vala"
	return result;
#line 2260 "SnapshotRepo.c"
}

static gint
___lambda9__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda9_ ((SnapshotRepo*) self, (Snapshot*) a, (Snapshot*) b);
#line 383 "Core/SnapshotRepo.vala"
	return result;
#line 2272 "SnapshotRepo.c"
}

GeeArrayList*
snapshot_repo_get_snapshots_by_tag (SnapshotRepo* self,
                                    const gchar* tag)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp17_;
	GeeArrayList* result = NULL;
#line 374 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 374 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 376 "Core/SnapshotRepo.vala"
	_tmp0_ = gee_array_list_new (TYPE_SNAPSHOT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 376 "Core/SnapshotRepo.vala"
	list = _tmp0_;
#line 2291 "SnapshotRepo.c"
	{
		GeeArrayList* _bak_list = NULL;
		GeeArrayList* _tmp1_;
		gint _bak_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _bak_index = 0;
#line 378 "Core/SnapshotRepo.vala"
		_tmp1_ = self->snapshots;
#line 378 "Core/SnapshotRepo.vala"
		_bak_list = _tmp1_;
#line 378 "Core/SnapshotRepo.vala"
		_tmp2_ = _bak_list;
#line 378 "Core/SnapshotRepo.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 378 "Core/SnapshotRepo.vala"
		_tmp4_ = _tmp3_;
#line 378 "Core/SnapshotRepo.vala"
		_bak_size = _tmp4_;
#line 378 "Core/SnapshotRepo.vala"
		_bak_index = -1;
#line 378 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 2316 "SnapshotRepo.c"
			gint _tmp5_;
			gint _tmp6_;
			Snapshot* bak = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			Snapshot* _tmp11_;
#line 378 "Core/SnapshotRepo.vala"
			_bak_index = _bak_index + 1;
#line 378 "Core/SnapshotRepo.vala"
			_tmp5_ = _bak_index;
#line 378 "Core/SnapshotRepo.vala"
			_tmp6_ = _bak_size;
#line 378 "Core/SnapshotRepo.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 378 "Core/SnapshotRepo.vala"
				break;
#line 2335 "SnapshotRepo.c"
			}
#line 378 "Core/SnapshotRepo.vala"
			_tmp7_ = _bak_list;
#line 378 "Core/SnapshotRepo.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _bak_index);
#line 378 "Core/SnapshotRepo.vala"
			bak = (Snapshot*) _tmp8_;
#line 379 "Core/SnapshotRepo.vala"
			_tmp11_ = bak;
#line 379 "Core/SnapshotRepo.vala"
			if (_tmp11_->valid) {
#line 2347 "SnapshotRepo.c"
				gint _tmp12_;
				gint _tmp13_;
#line 379 "Core/SnapshotRepo.vala"
				_tmp12_ = strlen (tag);
#line 379 "Core/SnapshotRepo.vala"
				_tmp13_ = _tmp12_;
#line 379 "Core/SnapshotRepo.vala"
				_tmp10_ = _tmp13_ == 0;
#line 2356 "SnapshotRepo.c"
			} else {
#line 379 "Core/SnapshotRepo.vala"
				_tmp10_ = FALSE;
#line 2360 "SnapshotRepo.c"
			}
#line 379 "Core/SnapshotRepo.vala"
			if (_tmp10_) {
#line 379 "Core/SnapshotRepo.vala"
				_tmp9_ = TRUE;
#line 2366 "SnapshotRepo.c"
			} else {
				Snapshot* _tmp14_;
#line 379 "Core/SnapshotRepo.vala"
				_tmp14_ = bak;
#line 379 "Core/SnapshotRepo.vala"
				_tmp9_ = snapshot_has_tag (_tmp14_, tag);
#line 2373 "SnapshotRepo.c"
			}
#line 379 "Core/SnapshotRepo.vala"
			if (_tmp9_) {
#line 2377 "SnapshotRepo.c"
				GeeArrayList* _tmp15_;
				Snapshot* _tmp16_;
#line 380 "Core/SnapshotRepo.vala"
				_tmp15_ = list;
#line 380 "Core/SnapshotRepo.vala"
				_tmp16_ = bak;
#line 380 "Core/SnapshotRepo.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 2386 "SnapshotRepo.c"
			}
#line 378 "Core/SnapshotRepo.vala"
			_g_object_unref0 (bak);
#line 2390 "SnapshotRepo.c"
		}
	}
#line 383 "Core/SnapshotRepo.vala"
	_tmp17_ = list;
#line 383 "Core/SnapshotRepo.vala"
	gee_list_sort ((GeeList*) _tmp17_, ___lambda9__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 389 "Core/SnapshotRepo.vala"
	result = list;
#line 389 "Core/SnapshotRepo.vala"
	return result;
#line 2401 "SnapshotRepo.c"
}

Snapshot*
snapshot_repo_get_latest_snapshot (SnapshotRepo* self,
                                   const gchar* tag,
                                   const gchar* sys_uuid)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	Snapshot* result = NULL;
#line 392 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 392 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 392 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (sys_uuid != NULL, NULL);
#line 394 "Core/SnapshotRepo.vala"
	_tmp0_ = snapshot_repo_get_snapshots_by_tag (self, tag);
#line 394 "Core/SnapshotRepo.vala"
	list = _tmp0_;
#line 2422 "SnapshotRepo.c"
	{
		gint i = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 396 "Core/SnapshotRepo.vala"
		_tmp1_ = list;
#line 396 "Core/SnapshotRepo.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 396 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_;
#line 396 "Core/SnapshotRepo.vala"
		i = _tmp3_ - 1;
#line 2436 "SnapshotRepo.c"
		{
			gboolean _tmp4_ = FALSE;
#line 396 "Core/SnapshotRepo.vala"
			_tmp4_ = TRUE;
#line 396 "Core/SnapshotRepo.vala"
			while (TRUE) {
#line 2443 "SnapshotRepo.c"
				Snapshot* bak = NULL;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				Snapshot* _tmp8_;
				const gchar* _tmp9_;
#line 396 "Core/SnapshotRepo.vala"
				if (!_tmp4_) {
#line 2451 "SnapshotRepo.c"
					gint _tmp5_;
#line 396 "Core/SnapshotRepo.vala"
					_tmp5_ = i;
#line 396 "Core/SnapshotRepo.vala"
					i = _tmp5_ - 1;
#line 2457 "SnapshotRepo.c"
				}
#line 396 "Core/SnapshotRepo.vala"
				_tmp4_ = FALSE;
#line 396 "Core/SnapshotRepo.vala"
				if (!(i >= 0)) {
#line 396 "Core/SnapshotRepo.vala"
					break;
#line 2465 "SnapshotRepo.c"
				}
#line 397 "Core/SnapshotRepo.vala"
				_tmp6_ = list;
#line 397 "Core/SnapshotRepo.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, i);
#line 397 "Core/SnapshotRepo.vala"
				bak = (Snapshot*) _tmp7_;
#line 398 "Core/SnapshotRepo.vala"
				_tmp8_ = bak;
#line 398 "Core/SnapshotRepo.vala"
				_tmp9_ = _tmp8_->sys_uuid;
#line 398 "Core/SnapshotRepo.vala"
				if (g_strcmp0 (_tmp9_, sys_uuid) == 0) {
#line 399 "Core/SnapshotRepo.vala"
					result = bak;
#line 399 "Core/SnapshotRepo.vala"
					_g_object_unref0 (list);
#line 399 "Core/SnapshotRepo.vala"
					return result;
#line 2485 "SnapshotRepo.c"
				}
#line 396 "Core/SnapshotRepo.vala"
				_g_object_unref0 (bak);
#line 2489 "SnapshotRepo.c"
			}
		}
	}
#line 403 "Core/SnapshotRepo.vala"
	result = NULL;
#line 403 "Core/SnapshotRepo.vala"
	_g_object_unref0 (list);
#line 403 "Core/SnapshotRepo.vala"
	return result;
#line 2499 "SnapshotRepo.c"
}

Snapshot*
snapshot_repo_get_oldest_snapshot (SnapshotRepo* self,
                                   const gchar* tag,
                                   const gchar* sys_uuid)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	Snapshot* result = NULL;
#line 406 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 406 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 406 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (sys_uuid != NULL, NULL);
#line 408 "Core/SnapshotRepo.vala"
	_tmp0_ = snapshot_repo_get_snapshots_by_tag (self, tag);
#line 408 "Core/SnapshotRepo.vala"
	list = _tmp0_;
#line 2520 "SnapshotRepo.c"
	{
		gint i = 0;
#line 410 "Core/SnapshotRepo.vala"
		i = 0;
#line 2525 "SnapshotRepo.c"
		{
			gboolean _tmp1_ = FALSE;
#line 410 "Core/SnapshotRepo.vala"
			_tmp1_ = TRUE;
#line 410 "Core/SnapshotRepo.vala"
			while (TRUE) {
#line 2532 "SnapshotRepo.c"
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				Snapshot* bak = NULL;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				Snapshot* _tmp8_;
				const gchar* _tmp9_;
#line 410 "Core/SnapshotRepo.vala"
				if (!_tmp1_) {
#line 2543 "SnapshotRepo.c"
					gint _tmp2_;
#line 410 "Core/SnapshotRepo.vala"
					_tmp2_ = i;
#line 410 "Core/SnapshotRepo.vala"
					i = _tmp2_ + 1;
#line 2549 "SnapshotRepo.c"
				}
#line 410 "Core/SnapshotRepo.vala"
				_tmp1_ = FALSE;
#line 410 "Core/SnapshotRepo.vala"
				_tmp3_ = list;
#line 410 "Core/SnapshotRepo.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 410 "Core/SnapshotRepo.vala"
				_tmp5_ = _tmp4_;
#line 410 "Core/SnapshotRepo.vala"
				if (!(i < _tmp5_)) {
#line 410 "Core/SnapshotRepo.vala"
					break;
#line 2563 "SnapshotRepo.c"
				}
#line 411 "Core/SnapshotRepo.vala"
				_tmp6_ = list;
#line 411 "Core/SnapshotRepo.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, i);
#line 411 "Core/SnapshotRepo.vala"
				bak = (Snapshot*) _tmp7_;
#line 412 "Core/SnapshotRepo.vala"
				_tmp8_ = bak;
#line 412 "Core/SnapshotRepo.vala"
				_tmp9_ = _tmp8_->sys_uuid;
#line 412 "Core/SnapshotRepo.vala"
				if (g_strcmp0 (_tmp9_, sys_uuid) == 0) {
#line 413 "Core/SnapshotRepo.vala"
					result = bak;
#line 413 "Core/SnapshotRepo.vala"
					_g_object_unref0 (list);
#line 413 "Core/SnapshotRepo.vala"
					return result;
#line 2583 "SnapshotRepo.c"
				}
#line 410 "Core/SnapshotRepo.vala"
				_g_object_unref0 (bak);
#line 2587 "SnapshotRepo.c"
			}
		}
	}
#line 417 "Core/SnapshotRepo.vala"
	result = NULL;
#line 417 "Core/SnapshotRepo.vala"
	_g_object_unref0 (list);
#line 417 "Core/SnapshotRepo.vala"
	return result;
#line 2597 "SnapshotRepo.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2619 "SnapshotRepo.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2623 "SnapshotRepo.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2629 "SnapshotRepo.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2633 "SnapshotRepo.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2637 "SnapshotRepo.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 2645 "SnapshotRepo.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2673 "SnapshotRepo.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 2682 "SnapshotRepo.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2696 "SnapshotRepo.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 2705 "SnapshotRepo.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 2719 "SnapshotRepo.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2728 "SnapshotRepo.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 2737 "SnapshotRepo.c"
}

void
snapshot_repo_check_status (SnapshotRepo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Main* _tmp3_;
#line 422 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 424 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: check_status()");
#line 426 "Core/SnapshotRepo.vala"
	self->status_code = SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_HAS_SPACE;
#line 427 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup ("");
#line 427 "Core/SnapshotRepo.vala"
	_g_free0 (self->status_message);
#line 427 "Core/SnapshotRepo.vala"
	self->status_message = _tmp0_;
#line 428 "Core/SnapshotRepo.vala"
	_tmp1_ = g_strdup ("");
#line 428 "Core/SnapshotRepo.vala"
	_g_free0 (self->status_details);
#line 428 "Core/SnapshotRepo.vala"
	self->status_details = _tmp1_;
#line 434 "Core/SnapshotRepo.vala"
	if (snapshot_repo_available (self)) {
#line 435 "Core/SnapshotRepo.vala"
		snapshot_repo_has_snapshots (self);
#line 436 "Core/SnapshotRepo.vala"
		snapshot_repo_has_space (self);
#line 2771 "SnapshotRepo.c"
	}
#line 439 "Core/SnapshotRepo.vala"
	_tmp3_ = App;
#line 439 "Core/SnapshotRepo.vala"
	if (_tmp3_ != NULL) {
#line 2777 "SnapshotRepo.c"
		Main* _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 439 "Core/SnapshotRepo.vala"
		_tmp4_ = App;
#line 439 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_->app_mode;
#line 439 "Core/SnapshotRepo.vala"
		_tmp6_ = strlen (_tmp5_);
#line 439 "Core/SnapshotRepo.vala"
		_tmp7_ = _tmp6_;
#line 439 "Core/SnapshotRepo.vala"
		_tmp2_ = _tmp7_ == 0;
#line 2792 "SnapshotRepo.c"
	} else {
#line 439 "Core/SnapshotRepo.vala"
		_tmp2_ = FALSE;
#line 2796 "SnapshotRepo.c"
	}
#line 439 "Core/SnapshotRepo.vala"
	if (_tmp2_) {
#line 2800 "SnapshotRepo.c"
		const gchar* _tmp8_ = NULL;
		Device* _tmp9_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GEnumValue* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 443 "Core/SnapshotRepo.vala"
		_tmp9_ = self->device;
#line 443 "Core/SnapshotRepo.vala"
		if (_tmp9_ == NULL) {
#line 443 "Core/SnapshotRepo.vala"
			_tmp8_ = " UNKNOWN";
#line 2821 "SnapshotRepo.c"
		} else {
			Device* _tmp10_;
			const gchar* _tmp11_;
#line 443 "Core/SnapshotRepo.vala"
			_tmp10_ = self->device;
#line 443 "Core/SnapshotRepo.vala"
			_tmp11_ = _tmp10_->device;
#line 443 "Core/SnapshotRepo.vala"
			_tmp8_ = _tmp11_;
#line 2831 "SnapshotRepo.c"
		}
#line 441 "Core/SnapshotRepo.vala"
		_tmp12_ = g_strdup_printf ("%s: '%s'", _ ("Snapshot device"), _tmp8_);
#line 441 "Core/SnapshotRepo.vala"
		_tmp13_ = _tmp12_;
#line 441 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp13_);
#line 441 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp13_);
#line 445 "Core/SnapshotRepo.vala"
		_tmp14_ = self->mount_path;
#line 445 "Core/SnapshotRepo.vala"
		_tmp15_ = g_strdup_printf ("%s: %s", _ ("Snapshot location"), _tmp14_);
#line 445 "Core/SnapshotRepo.vala"
		_tmp16_ = _tmp15_;
#line 445 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp16_);
#line 445 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp16_);
#line 448 "Core/SnapshotRepo.vala"
		_tmp17_ = self->status_message;
#line 448 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp17_);
#line 449 "Core/SnapshotRepo.vala"
		_tmp18_ = self->status_details;
#line 449 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp18_);
#line 453 "Core/SnapshotRepo.vala"
		_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_SNAPSHOT_LOCATION_STATUS), self->status_code);
#line 451 "Core/SnapshotRepo.vala"
		_tmp20_ = string_replace ((_tmp19_ != NULL) ? _tmp19_->value_name : NULL, "SNAPSHOT_LOCATION_STATUS_", "");
#line 451 "Core/SnapshotRepo.vala"
		_tmp21_ = _tmp20_;
#line 451 "Core/SnapshotRepo.vala"
		_tmp22_ = g_strdup_printf ("%s: %s", _ ("Status"), _tmp21_);
#line 451 "Core/SnapshotRepo.vala"
		_tmp23_ = _tmp22_;
#line 451 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug (_tmp23_);
#line 451 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp23_);
#line 451 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp21_);
#line 455 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("");
#line 2877 "SnapshotRepo.c"
	}
#line 458 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: check_status(): exit");
#line 2881 "SnapshotRepo.c"
}

gboolean
snapshot_repo_available (SnapshotRepo* self)
{
	Device* _tmp0_;
	gboolean result = FALSE;
#line 461 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 463 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: available()");
#line 521 "Core/SnapshotRepo.vala"
	_tmp0_ = self->device;
#line 521 "Core/SnapshotRepo.vala"
	if (_tmp0_ == NULL) {
#line 2897 "SnapshotRepo.c"
		Main* _tmp1_;
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 522 "Core/SnapshotRepo.vala"
		_tmp1_ = App;
#line 522 "Core/SnapshotRepo.vala"
		_tmp2_ = _tmp1_->backup_uuid;
#line 522 "Core/SnapshotRepo.vala"
		_tmp3_ = strlen (_tmp2_);
#line 522 "Core/SnapshotRepo.vala"
		_tmp4_ = _tmp3_;
#line 522 "Core/SnapshotRepo.vala"
		if (_tmp4_ == 0) {
#line 2912 "SnapshotRepo.c"
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 523 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug ("device is null");
#line 524 "Core/SnapshotRepo.vala"
			_tmp5_ = g_strdup (_ ("Snapshot device not selected"));
#line 524 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 524 "Core/SnapshotRepo.vala"
			self->status_message = _tmp5_;
#line 525 "Core/SnapshotRepo.vala"
			_tmp6_ = g_strdup (_ ("Select the snapshot device"));
#line 525 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 525 "Core/SnapshotRepo.vala"
			self->status_details = _tmp6_;
#line 526 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_NOT_SELECTED;
#line 527 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug ("is_available: false");
#line 528 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 528 "Core/SnapshotRepo.vala"
			return result;
#line 2937 "SnapshotRepo.c"
		} else {
			gchar* _tmp7_;
			Main* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 531 "Core/SnapshotRepo.vala"
			_tmp7_ = g_strdup (_ ("Snapshot device not available"));
#line 531 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 531 "Core/SnapshotRepo.vala"
			self->status_message = _tmp7_;
#line 532 "Core/SnapshotRepo.vala"
			_tmp8_ = App;
#line 532 "Core/SnapshotRepo.vala"
			_tmp9_ = _tmp8_->backup_uuid;
#line 532 "Core/SnapshotRepo.vala"
			_tmp10_ = g_strdup_printf (": UUID='%s'", _tmp9_);
#line 532 "Core/SnapshotRepo.vala"
			_tmp11_ = _tmp10_;
#line 532 "Core/SnapshotRepo.vala"
			_tmp12_ = g_strconcat (_ ("Device not found"), _tmp11_, NULL);
#line 532 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 532 "Core/SnapshotRepo.vala"
			self->status_details = _tmp12_;
#line 532 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp11_);
#line 533 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_NOT_AVAILABLE;
#line 534 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug ("is_available: false");
#line 535 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 535 "Core/SnapshotRepo.vala"
			return result;
#line 2975 "SnapshotRepo.c"
		}
	} else {
#line 539 "Core/SnapshotRepo.vala"
		if (self->btrfs_mode) {
#line 2980 "SnapshotRepo.c"
			gboolean ok = FALSE;
#line 540 "Core/SnapshotRepo.vala"
			ok = snapshot_repo_has_btrfs_system (self);
#line 541 "Core/SnapshotRepo.vala"
			if (ok) {
#line 542 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_debug ("is_available: ok");
#line 2988 "SnapshotRepo.c"
			}
#line 544 "Core/SnapshotRepo.vala"
			result = ok;
#line 544 "Core/SnapshotRepo.vala"
			return result;
#line 2994 "SnapshotRepo.c"
		} else {
#line 547 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug ("is_available: ok");
#line 548 "Core/SnapshotRepo.vala"
			result = TRUE;
#line 548 "Core/SnapshotRepo.vala"
			return result;
#line 3002 "SnapshotRepo.c"
		}
	}
#line 552 "Core/SnapshotRepo.vala"
	result = FALSE;
#line 552 "Core/SnapshotRepo.vala"
	return result;
#line 3009 "SnapshotRepo.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 3018 "SnapshotRepo.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 3026 "SnapshotRepo.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 3035 "SnapshotRepo.c"
	}
}

gboolean
snapshot_repo_has_btrfs_system (SnapshotRepo* self)
{
	gchar* root_path = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean result = FALSE;
#line 555 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 557 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: has_btrfs_system()");
#line 559 "Core/SnapshotRepo.vala"
	_tmp0_ = self->mount_paths;
#line 559 "Core/SnapshotRepo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, "@");
#line 559 "Core/SnapshotRepo.vala"
	_tmp2_ = (gchar*) _tmp1_;
#line 559 "Core/SnapshotRepo.vala"
	_tmp3_ = tee_jee_file_system_path_combine (_tmp2_, "@");
#line 559 "Core/SnapshotRepo.vala"
	_tmp4_ = _tmp3_;
#line 559 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp2_);
#line 559 "Core/SnapshotRepo.vala"
	root_path = _tmp4_;
#line 560 "Core/SnapshotRepo.vala"
	_tmp5_ = root_path;
#line 560 "Core/SnapshotRepo.vala"
	_tmp6_ = g_strdup_printf ("root_path=%s", _tmp5_);
#line 560 "Core/SnapshotRepo.vala"
	_tmp7_ = _tmp6_;
#line 560 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_tmp7_);
#line 560 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp7_);
#line 561 "Core/SnapshotRepo.vala"
	_tmp8_ = bool_to_string (self->btrfs_mode);
#line 561 "Core/SnapshotRepo.vala"
	_tmp9_ = _tmp8_;
#line 561 "Core/SnapshotRepo.vala"
	_tmp10_ = g_strdup_printf ("btrfs_mode=%s", _tmp9_);
#line 561 "Core/SnapshotRepo.vala"
	_tmp11_ = _tmp10_;
#line 561 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_tmp11_);
#line 561 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp11_);
#line 561 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp9_);
#line 562 "Core/SnapshotRepo.vala"
	if (self->btrfs_mode) {
#line 3100 "SnapshotRepo.c"
		const gchar* _tmp12_;
#line 563 "Core/SnapshotRepo.vala"
		_tmp12_ = root_path;
#line 563 "Core/SnapshotRepo.vala"
		if (!tee_jee_file_system_dir_exists (_tmp12_)) {
#line 3106 "SnapshotRepo.c"
			gchar* _tmp13_;
			gchar* _tmp14_;
			const gchar* _tmp15_;
#line 564 "Core/SnapshotRepo.vala"
			_tmp13_ = g_strdup (_ ("Selected snapshot device is not a system disk"));
#line 564 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 564 "Core/SnapshotRepo.vala"
			self->status_message = _tmp13_;
#line 565 "Core/SnapshotRepo.vala"
			_tmp14_ = g_strdup (_ ("Select BTRFS system disk with root subvolume (@)"));
#line 565 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 565 "Core/SnapshotRepo.vala"
			self->status_details = _tmp14_;
#line 566 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_NO_BTRFS_SYSTEM;
#line 567 "Core/SnapshotRepo.vala"
			_tmp15_ = self->status_message;
#line 567 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_debug (_tmp15_);
#line 568 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 568 "Core/SnapshotRepo.vala"
			_g_free0 (root_path);
#line 568 "Core/SnapshotRepo.vala"
			return result;
#line 3134 "SnapshotRepo.c"
		}
	}
#line 572 "Core/SnapshotRepo.vala"
	result = TRUE;
#line 572 "Core/SnapshotRepo.vala"
	_g_free0 (root_path);
#line 572 "Core/SnapshotRepo.vala"
	return result;
#line 3143 "SnapshotRepo.c"
}

gboolean
snapshot_repo_has_snapshots (SnapshotRepo* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result = FALSE;
#line 575 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 577 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: has_snapshots()");
#line 580 "Core/SnapshotRepo.vala"
	_tmp0_ = self->snapshots;
#line 580 "Core/SnapshotRepo.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 580 "Core/SnapshotRepo.vala"
	_tmp2_ = _tmp1_;
#line 580 "Core/SnapshotRepo.vala"
	result = _tmp2_ > 0;
#line 580 "Core/SnapshotRepo.vala"
	return result;
#line 3167 "SnapshotRepo.c"
}

gboolean
snapshot_repo_has_space (SnapshotRepo* self)
{
	gboolean _tmp0_ = FALSE;
	Device* _tmp1_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean result = FALSE;
#line 583 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 585 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: has_space()");
#line 587 "Core/SnapshotRepo.vala"
	_tmp1_ = self->device;
#line 587 "Core/SnapshotRepo.vala"
	if (_tmp1_ != NULL) {
#line 3187 "SnapshotRepo.c"
		Device* _tmp2_;
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 587 "Core/SnapshotRepo.vala"
		_tmp2_ = self->device;
#line 587 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_->device;
#line 587 "Core/SnapshotRepo.vala"
		_tmp4_ = strlen (_tmp3_);
#line 587 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 587 "Core/SnapshotRepo.vala"
		_tmp0_ = _tmp5_ > 0;
#line 3202 "SnapshotRepo.c"
	} else {
#line 587 "Core/SnapshotRepo.vala"
		_tmp0_ = FALSE;
#line 3206 "SnapshotRepo.c"
	}
#line 587 "Core/SnapshotRepo.vala"
	if (_tmp0_) {
#line 3210 "SnapshotRepo.c"
		Device* _tmp6_;
#line 588 "Core/SnapshotRepo.vala"
		_tmp6_ = self->device;
#line 588 "Core/SnapshotRepo.vala"
		device_query_disk_space (_tmp6_);
#line 3216 "SnapshotRepo.c"
	} else {
#line 591 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("device is NULL");
#line 592 "Core/SnapshotRepo.vala"
		result = FALSE;
#line 592 "Core/SnapshotRepo.vala"
		return result;
#line 3224 "SnapshotRepo.c"
	}
#line 595 "Core/SnapshotRepo.vala"
	_tmp7_ = self->snapshots;
#line 595 "Core/SnapshotRepo.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 595 "Core/SnapshotRepo.vala"
	_tmp9_ = _tmp8_;
#line 595 "Core/SnapshotRepo.vala"
	if (_tmp9_ > 0) {
#line 3234 "SnapshotRepo.c"
		Device* _tmp10_;
		guint64 _tmp11_;
		guint64 _tmp12_;
#line 600 "Core/SnapshotRepo.vala"
		_tmp10_ = self->device;
#line 600 "Core/SnapshotRepo.vala"
		_tmp11_ = device_get_free_bytes (_tmp10_);
#line 600 "Core/SnapshotRepo.vala"
		_tmp12_ = _tmp11_;
#line 600 "Core/SnapshotRepo.vala"
		if (_tmp12_ < MAIN_MIN_FREE_SPACE) {
#line 3246 "SnapshotRepo.c"
			gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 601 "Core/SnapshotRepo.vala"
			_tmp13_ = g_strdup (_ ("Not enough disk space"));
#line 601 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 601 "Core/SnapshotRepo.vala"
			self->status_message = _tmp13_;
#line 602 "Core/SnapshotRepo.vala"
			_tmp14_ = self->status_message;
#line 602 "Core/SnapshotRepo.vala"
			_tmp15_ = tee_jee_file_system_format_file_size (MAIN_MIN_FREE_SPACE, FALSE, "", TRUE, 0);
#line 602 "Core/SnapshotRepo.vala"
			_tmp16_ = _tmp15_;
#line 602 "Core/SnapshotRepo.vala"
			_tmp17_ = g_strdup_printf (" (< %s)", _tmp16_);
#line 602 "Core/SnapshotRepo.vala"
			_tmp18_ = _tmp17_;
#line 602 "Core/SnapshotRepo.vala"
			_tmp19_ = g_strconcat (_tmp14_, _tmp18_, NULL);
#line 602 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 602 "Core/SnapshotRepo.vala"
			self->status_message = _tmp19_;
#line 602 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp18_);
#line 602 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp16_);
#line 604 "Core/SnapshotRepo.vala"
			_tmp20_ = g_strdup (_ ("Select another device or free up some space"));
#line 604 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 604 "Core/SnapshotRepo.vala"
			self->status_details = _tmp20_;
#line 606 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_NO_SPACE;
#line 607 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 607 "Core/SnapshotRepo.vala"
			return result;
#line 3293 "SnapshotRepo.c"
		} else {
			gchar* _tmp21_;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			Device* _tmp25_;
			guint64 _tmp26_;
			guint64 _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 611 "Core/SnapshotRepo.vala"
			_tmp21_ = g_strdup (_ ("OK"));
#line 611 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 611 "Core/SnapshotRepo.vala"
			self->status_message = _tmp21_;
#line 613 "Core/SnapshotRepo.vala"
			_tmp22_ = self->snapshots;
#line 613 "Core/SnapshotRepo.vala"
			_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 613 "Core/SnapshotRepo.vala"
			_tmp24_ = _tmp23_;
#line 613 "Core/SnapshotRepo.vala"
			_tmp25_ = self->device;
#line 613 "Core/SnapshotRepo.vala"
			_tmp26_ = device_get_free_bytes (_tmp25_);
#line 613 "Core/SnapshotRepo.vala"
			_tmp27_ = _tmp26_;
#line 613 "Core/SnapshotRepo.vala"
			_tmp28_ = tee_jee_file_system_format_file_size (_tmp27_, FALSE, "", TRUE, 1);
#line 613 "Core/SnapshotRepo.vala"
			_tmp29_ = _tmp28_;
#line 613 "Core/SnapshotRepo.vala"
			_tmp30_ = g_strdup_printf (_ ("%d snapshots, %s free"), _tmp24_, _tmp29_);
#line 613 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 613 "Core/SnapshotRepo.vala"
			self->status_details = _tmp30_;
#line 613 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp29_);
#line 616 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_HAS_SPACE;
#line 617 "Core/SnapshotRepo.vala"
			result = TRUE;
#line 617 "Core/SnapshotRepo.vala"
			return result;
#line 3341 "SnapshotRepo.c"
		}
	} else {
		guint64 required_space = 0ULL;
		Device* _tmp31_;
		guint64 _tmp32_;
		guint64 _tmp33_;
#line 623 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_debug ("no snapshots");
#line 625 "Core/SnapshotRepo.vala"
		required_space = main_first_snapshot_size;
#line 627 "Core/SnapshotRepo.vala"
		_tmp31_ = self->device;
#line 627 "Core/SnapshotRepo.vala"
		_tmp32_ = device_get_free_bytes (_tmp31_);
#line 627 "Core/SnapshotRepo.vala"
		_tmp33_ = _tmp32_;
#line 627 "Core/SnapshotRepo.vala"
		if (_tmp33_ < required_space) {
#line 3360 "SnapshotRepo.c"
			gchar* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
#line 628 "Core/SnapshotRepo.vala"
			_tmp34_ = g_strdup (_ ("Not enough disk space"));
#line 628 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 628 "Core/SnapshotRepo.vala"
			self->status_message = _tmp34_;
#line 629 "Core/SnapshotRepo.vala"
			_tmp35_ = self->status_message;
#line 629 "Core/SnapshotRepo.vala"
			_tmp36_ = tee_jee_file_system_format_file_size (required_space, FALSE, "", TRUE, 1);
#line 629 "Core/SnapshotRepo.vala"
			_tmp37_ = _tmp36_;
#line 629 "Core/SnapshotRepo.vala"
			_tmp38_ = g_strdup_printf (" (< %s)", _tmp37_);
#line 629 "Core/SnapshotRepo.vala"
			_tmp39_ = _tmp38_;
#line 629 "Core/SnapshotRepo.vala"
			_tmp40_ = g_strconcat (_tmp35_, _tmp39_, NULL);
#line 629 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 629 "Core/SnapshotRepo.vala"
			self->status_message = _tmp40_;
#line 629 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp39_);
#line 629 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp37_);
#line 631 "Core/SnapshotRepo.vala"
			_tmp41_ = g_strdup (_ ("Select another device or free up some space"));
#line 631 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 631 "Core/SnapshotRepo.vala"
			self->status_details = _tmp41_;
#line 633 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_NO_SPACE;
#line 634 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 634 "Core/SnapshotRepo.vala"
			return result;
#line 3407 "SnapshotRepo.c"
		} else {
			gchar* _tmp42_;
			gchar* _tmp43_;
			const gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
#line 637 "Core/SnapshotRepo.vala"
			_tmp42_ = g_strdup (_ ("No snapshots on this device"));
#line 637 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_message);
#line 637 "Core/SnapshotRepo.vala"
			self->status_message = _tmp42_;
#line 639 "Core/SnapshotRepo.vala"
			_tmp43_ = g_strdup (_ ("First snapshot requires:"));
#line 639 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 639 "Core/SnapshotRepo.vala"
			self->status_details = _tmp43_;
#line 640 "Core/SnapshotRepo.vala"
			_tmp44_ = self->status_details;
#line 640 "Core/SnapshotRepo.vala"
			_tmp45_ = tee_jee_file_system_format_file_size (required_space, FALSE, "", TRUE, 1);
#line 640 "Core/SnapshotRepo.vala"
			_tmp46_ = _tmp45_;
#line 640 "Core/SnapshotRepo.vala"
			_tmp47_ = g_strdup_printf (" %s", _tmp46_);
#line 640 "Core/SnapshotRepo.vala"
			_tmp48_ = _tmp47_;
#line 640 "Core/SnapshotRepo.vala"
			_tmp49_ = g_strconcat (_tmp44_, _tmp48_, NULL);
#line 640 "Core/SnapshotRepo.vala"
			_g_free0 (self->status_details);
#line 640 "Core/SnapshotRepo.vala"
			self->status_details = _tmp49_;
#line 640 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp48_);
#line 640 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp46_);
#line 642 "Core/SnapshotRepo.vala"
			self->status_code = SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_HAS_SPACE;
#line 643 "Core/SnapshotRepo.vala"
			result = TRUE;
#line 643 "Core/SnapshotRepo.vala"
			return result;
#line 3455 "SnapshotRepo.c"
		}
	}
}

void
snapshot_repo_print_status (SnapshotRepo* self)
{
	Device* _tmp0_;
#line 648 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 650 "Core/SnapshotRepo.vala"
	snapshot_repo_check_status (self);
#line 654 "Core/SnapshotRepo.vala"
	_tmp0_ = self->device;
#line 654 "Core/SnapshotRepo.vala"
	if (_tmp0_ == NULL) {
#line 3472 "SnapshotRepo.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 655 "Core/SnapshotRepo.vala"
		_tmp1_ = g_strdup_printf ("%-6s : %s", _ ("Device"), _ ("Not Selected"));
#line 655 "Core/SnapshotRepo.vala"
		_tmp2_ = _tmp1_;
#line 655 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp2_, FALSE);
#line 655 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp2_);
#line 3483 "SnapshotRepo.c"
	} else {
		Device* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		Device* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
#line 658 "Core/SnapshotRepo.vala"
		_tmp3_ = self->device;
#line 658 "Core/SnapshotRepo.vala"
		_tmp4_ = device_get_device_name_with_parent (_tmp3_);
#line 658 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 658 "Core/SnapshotRepo.vala"
		_tmp6_ = _tmp5_;
#line 658 "Core/SnapshotRepo.vala"
		_tmp7_ = g_strdup_printf ("%-6s : %s", _ ("Device"), _tmp6_);
#line 658 "Core/SnapshotRepo.vala"
		_tmp8_ = _tmp7_;
#line 658 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp8_, FALSE);
#line 658 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp8_);
#line 658 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp6_);
#line 659 "Core/SnapshotRepo.vala"
		_tmp9_ = self->device;
#line 659 "Core/SnapshotRepo.vala"
		_tmp10_ = _tmp9_->uuid;
#line 659 "Core/SnapshotRepo.vala"
		_tmp11_ = g_strdup_printf ("%-6s : %s", "UUID", _tmp10_);
#line 659 "Core/SnapshotRepo.vala"
		_tmp12_ = _tmp11_;
#line 659 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp12_, FALSE);
#line 659 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp12_);
#line 660 "Core/SnapshotRepo.vala"
		_tmp13_ = self->mount_path;
#line 660 "Core/SnapshotRepo.vala"
		_tmp14_ = g_strdup_printf ("%-6s : %s", _ ("Path"), _tmp13_);
#line 660 "Core/SnapshotRepo.vala"
		_tmp15_ = _tmp14_;
#line 660 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp15_, FALSE);
#line 660 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp15_);
#line 661 "Core/SnapshotRepo.vala"
		if (self->btrfs_mode) {
#line 661 "Core/SnapshotRepo.vala"
			_tmp16_ = "BTRFS";
#line 3549 "SnapshotRepo.c"
		} else {
#line 661 "Core/SnapshotRepo.vala"
			_tmp16_ = "RSYNC";
#line 3553 "SnapshotRepo.c"
		}
#line 661 "Core/SnapshotRepo.vala"
		_tmp17_ = g_strdup_printf ("%-6s : %s", _ ("Mode"), _tmp16_);
#line 661 "Core/SnapshotRepo.vala"
		_tmp18_ = _tmp17_;
#line 661 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp18_, FALSE);
#line 661 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp18_);
#line 662 "Core/SnapshotRepo.vala"
		_tmp19_ = self->status_message;
#line 662 "Core/SnapshotRepo.vala"
		_tmp20_ = g_strdup_printf ("%-6s : %s", _ ("Status"), _tmp19_);
#line 662 "Core/SnapshotRepo.vala"
		_tmp21_ = _tmp20_;
#line 662 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp21_, FALSE);
#line 662 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp21_);
#line 663 "Core/SnapshotRepo.vala"
		_tmp22_ = self->status_details;
#line 663 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp22_, FALSE);
#line 3577 "SnapshotRepo.c"
	}
#line 666 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 3581 "SnapshotRepo.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 3602 "SnapshotRepo.c"
}

void
snapshot_repo_auto_remove (SnapshotRepo* self)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GDateTime* dt_limit = NULL;
	gint count_limit = 0;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	Main* _tmp5_;
	gchar** levels = NULL;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar** _tmp36_;
	gint levels_length1;
	gint _levels_size_;
	gchar** _tmp37_;
	gint _tmp37__length1;
#line 671 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 673 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: auto_remove()");
#line 675 "Core/SnapshotRepo.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 675 "Core/SnapshotRepo.vala"
	now = _tmp0_;
#line 681 "Core/SnapshotRepo.vala"
	_tmp1_ = snapshot_repo_get_snapshots_by_tag (self, "boot");
#line 681 "Core/SnapshotRepo.vala"
	list = _tmp1_;
#line 683 "Core/SnapshotRepo.vala"
	_tmp2_ = list;
#line 683 "Core/SnapshotRepo.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 683 "Core/SnapshotRepo.vala"
	_tmp4_ = _tmp3_;
#line 683 "Core/SnapshotRepo.vala"
	_tmp5_ = App;
#line 683 "Core/SnapshotRepo.vala"
	if (_tmp4_ > _tmp5_->count_boot) {
#line 3650 "SnapshotRepo.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 684 "Core/SnapshotRepo.vala"
		_tmp6_ = g_strdup_printf (" '%s'", "boot");
#line 684 "Core/SnapshotRepo.vala"
		_tmp7_ = _tmp6_;
#line 684 "Core/SnapshotRepo.vala"
		_tmp8_ = g_strconcat (_ ("Maximum backups exceeded for backup level"), _tmp7_, NULL);
#line 684 "Core/SnapshotRepo.vala"
		_tmp9_ = _tmp8_;
#line 684 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp9_, FALSE);
#line 684 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp9_);
#line 684 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp7_);
#line 685 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 3671 "SnapshotRepo.c"
			GeeArrayList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			Main* _tmp13_;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			Snapshot* _tmp16_;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			Snapshot* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			GeeArrayList* _tmp31_;
#line 685 "Core/SnapshotRepo.vala"
			_tmp10_ = list;
#line 685 "Core/SnapshotRepo.vala"
			_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 685 "Core/SnapshotRepo.vala"
			_tmp12_ = _tmp11_;
#line 685 "Core/SnapshotRepo.vala"
			_tmp13_ = App;
#line 685 "Core/SnapshotRepo.vala"
			if (!(_tmp12_ > _tmp13_->count_boot)) {
#line 685 "Core/SnapshotRepo.vala"
				break;
#line 3706 "SnapshotRepo.c"
			}
#line 686 "Core/SnapshotRepo.vala"
			_tmp14_ = list;
#line 686 "Core/SnapshotRepo.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, 0);
#line 686 "Core/SnapshotRepo.vala"
			_tmp16_ = (Snapshot*) _tmp15_;
#line 686 "Core/SnapshotRepo.vala"
			snapshot_remove_tag (_tmp16_, "boot");
#line 686 "Core/SnapshotRepo.vala"
			_g_object_unref0 (_tmp16_);
#line 687 "Core/SnapshotRepo.vala"
			_tmp17_ = list;
#line 687 "Core/SnapshotRepo.vala"
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, 0);
#line 687 "Core/SnapshotRepo.vala"
			_tmp19_ = (Snapshot*) _tmp18_;
#line 687 "Core/SnapshotRepo.vala"
			_tmp20_ = _tmp19_->name;
#line 687 "Core/SnapshotRepo.vala"
			_tmp21_ = g_strdup_printf (" '%s' ", _tmp20_);
#line 687 "Core/SnapshotRepo.vala"
			_tmp22_ = _tmp21_;
#line 687 "Core/SnapshotRepo.vala"
			_tmp23_ = g_strconcat (_ ("Snapshot"), _tmp22_, NULL);
#line 687 "Core/SnapshotRepo.vala"
			_tmp24_ = _tmp23_;
#line 687 "Core/SnapshotRepo.vala"
			_tmp25_ = g_strconcat (_tmp24_, _ ("un-tagged"), NULL);
#line 687 "Core/SnapshotRepo.vala"
			_tmp26_ = _tmp25_;
#line 687 "Core/SnapshotRepo.vala"
			_tmp27_ = g_strdup_printf (" '%s'", "boot");
#line 687 "Core/SnapshotRepo.vala"
			_tmp28_ = _tmp27_;
#line 687 "Core/SnapshotRepo.vala"
			_tmp29_ = g_strconcat (_tmp26_, _tmp28_, NULL);
#line 687 "Core/SnapshotRepo.vala"
			_tmp30_ = _tmp29_;
#line 687 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_msg (_tmp30_, FALSE);
#line 687 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp30_);
#line 687 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp28_);
#line 687 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp26_);
#line 687 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp24_);
#line 687 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp22_);
#line 687 "Core/SnapshotRepo.vala"
			_g_object_unref0 (_tmp19_);
#line 688 "Core/SnapshotRepo.vala"
			_tmp31_ = snapshot_repo_get_snapshots_by_tag (self, "boot");
#line 688 "Core/SnapshotRepo.vala"
			_g_object_unref0 (list);
#line 688 "Core/SnapshotRepo.vala"
			list = _tmp31_;
#line 3766 "SnapshotRepo.c"
		}
	}
#line 694 "Core/SnapshotRepo.vala"
	_tmp32_ = g_strdup ("hourly");
#line 694 "Core/SnapshotRepo.vala"
	_tmp33_ = g_strdup ("daily");
#line 694 "Core/SnapshotRepo.vala"
	_tmp34_ = g_strdup ("weekly");
#line 694 "Core/SnapshotRepo.vala"
	_tmp35_ = g_strdup ("monthly");
#line 694 "Core/SnapshotRepo.vala"
	_tmp36_ = g_new0 (gchar*, 4 + 1);
#line 694 "Core/SnapshotRepo.vala"
	_tmp36_[0] = _tmp32_;
#line 694 "Core/SnapshotRepo.vala"
	_tmp36_[1] = _tmp33_;
#line 694 "Core/SnapshotRepo.vala"
	_tmp36_[2] = _tmp34_;
#line 694 "Core/SnapshotRepo.vala"
	_tmp36_[3] = _tmp35_;
#line 694 "Core/SnapshotRepo.vala"
	levels = _tmp36_;
#line 694 "Core/SnapshotRepo.vala"
	levels_length1 = 4;
#line 694 "Core/SnapshotRepo.vala"
	_levels_size_ = levels_length1;
#line 696 "Core/SnapshotRepo.vala"
	_tmp37_ = levels;
#line 696 "Core/SnapshotRepo.vala"
	_tmp37__length1 = levels_length1;
#line 3797 "SnapshotRepo.c"
	{
		gchar** level_collection = NULL;
		gint level_collection_length1 = 0;
		gint _level_collection_size_ = 0;
		gint level_it = 0;
#line 696 "Core/SnapshotRepo.vala"
		level_collection = _tmp37_;
#line 696 "Core/SnapshotRepo.vala"
		level_collection_length1 = _tmp37__length1;
#line 696 "Core/SnapshotRepo.vala"
		for (level_it = 0; level_it < level_collection_length1; level_it = level_it + 1) {
#line 3809 "SnapshotRepo.c"
			gchar* _tmp38_;
			gchar* level = NULL;
#line 696 "Core/SnapshotRepo.vala"
			_tmp38_ = g_strdup (level_collection[level_it]);
#line 696 "Core/SnapshotRepo.vala"
			level = _tmp38_;
#line 3816 "SnapshotRepo.c"
			{
				const gchar* _tmp39_;
				GeeArrayList* _tmp40_;
				GeeArrayList* _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				GQuark _tmp47_ = 0U;
#line 702 "Core/SnapshotRepo.vala"
				static GQuark _tmp46_label0 = 0;
#line 702 "Core/SnapshotRepo.vala"
				static GQuark _tmp46_label1 = 0;
#line 702 "Core/SnapshotRepo.vala"
				static GQuark _tmp46_label2 = 0;
#line 702 "Core/SnapshotRepo.vala"
				static GQuark _tmp46_label3 = 0;
#line 3834 "SnapshotRepo.c"
				GeeArrayList* _tmp66_;
				gint _tmp67_;
				gint _tmp68_;
#line 698 "Core/SnapshotRepo.vala"
				_tmp39_ = level;
#line 698 "Core/SnapshotRepo.vala"
				_tmp40_ = snapshot_repo_get_snapshots_by_tag (self, _tmp39_);
#line 698 "Core/SnapshotRepo.vala"
				_g_object_unref0 (list);
#line 698 "Core/SnapshotRepo.vala"
				list = _tmp40_;
#line 700 "Core/SnapshotRepo.vala"
				_tmp41_ = list;
#line 700 "Core/SnapshotRepo.vala"
				_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 700 "Core/SnapshotRepo.vala"
				_tmp43_ = _tmp42_;
#line 700 "Core/SnapshotRepo.vala"
				if (_tmp43_ == 0) {
#line 700 "Core/SnapshotRepo.vala"
					_g_free0 (level);
#line 700 "Core/SnapshotRepo.vala"
					continue;
#line 3858 "SnapshotRepo.c"
				}
#line 702 "Core/SnapshotRepo.vala"
				_tmp44_ = level;
#line 702 "Core/SnapshotRepo.vala"
				_tmp45_ = _tmp44_;
#line 702 "Core/SnapshotRepo.vala"
				_tmp47_ = (NULL == _tmp45_) ? 0 : g_quark_from_string (_tmp45_);
#line 702 "Core/SnapshotRepo.vala"
				if (_tmp47_ == ((0 != _tmp46_label0) ? _tmp46_label0 : (_tmp46_label0 = g_quark_from_static_string ("hourly")))) {
#line 702 "Core/SnapshotRepo.vala"
					switch (0) {
#line 3870 "SnapshotRepo.c"
						default:
						{
							GDateTime* _tmp48_;
							Main* _tmp49_;
							GDateTime* _tmp50_;
							Main* _tmp51_;
#line 704 "Core/SnapshotRepo.vala"
							_tmp48_ = now;
#line 704 "Core/SnapshotRepo.vala"
							_tmp49_ = App;
#line 704 "Core/SnapshotRepo.vala"
							_tmp50_ = g_date_time_add_hours (_tmp48_, -1 * _tmp49_->count_hourly);
#line 704 "Core/SnapshotRepo.vala"
							_g_date_time_unref0 (dt_limit);
#line 704 "Core/SnapshotRepo.vala"
							dt_limit = _tmp50_;
#line 705 "Core/SnapshotRepo.vala"
							_tmp51_ = App;
#line 705 "Core/SnapshotRepo.vala"
							count_limit = _tmp51_->count_hourly;
#line 706 "Core/SnapshotRepo.vala"
							break;
#line 3893 "SnapshotRepo.c"
						}
					}
				} else if (_tmp47_ == ((0 != _tmp46_label1) ? _tmp46_label1 : (_tmp46_label1 = g_quark_from_static_string ("daily")))) {
#line 702 "Core/SnapshotRepo.vala"
					switch (0) {
#line 3899 "SnapshotRepo.c"
						default:
						{
							GDateTime* _tmp52_;
							Main* _tmp53_;
							GDateTime* _tmp54_;
							Main* _tmp55_;
#line 708 "Core/SnapshotRepo.vala"
							_tmp52_ = now;
#line 708 "Core/SnapshotRepo.vala"
							_tmp53_ = App;
#line 708 "Core/SnapshotRepo.vala"
							_tmp54_ = g_date_time_add_days (_tmp52_, -1 * _tmp53_->count_daily);
#line 708 "Core/SnapshotRepo.vala"
							_g_date_time_unref0 (dt_limit);
#line 708 "Core/SnapshotRepo.vala"
							dt_limit = _tmp54_;
#line 709 "Core/SnapshotRepo.vala"
							_tmp55_ = App;
#line 709 "Core/SnapshotRepo.vala"
							count_limit = _tmp55_->count_daily;
#line 710 "Core/SnapshotRepo.vala"
							break;
#line 3922 "SnapshotRepo.c"
						}
					}
				} else if (_tmp47_ == ((0 != _tmp46_label2) ? _tmp46_label2 : (_tmp46_label2 = g_quark_from_static_string ("weekly")))) {
#line 702 "Core/SnapshotRepo.vala"
					switch (0) {
#line 3928 "SnapshotRepo.c"
						default:
						{
							GDateTime* _tmp56_;
							Main* _tmp57_;
							GDateTime* _tmp58_;
							Main* _tmp59_;
#line 712 "Core/SnapshotRepo.vala"
							_tmp56_ = now;
#line 712 "Core/SnapshotRepo.vala"
							_tmp57_ = App;
#line 712 "Core/SnapshotRepo.vala"
							_tmp58_ = g_date_time_add_weeks (_tmp56_, -1 * _tmp57_->count_weekly);
#line 712 "Core/SnapshotRepo.vala"
							_g_date_time_unref0 (dt_limit);
#line 712 "Core/SnapshotRepo.vala"
							dt_limit = _tmp58_;
#line 713 "Core/SnapshotRepo.vala"
							_tmp59_ = App;
#line 713 "Core/SnapshotRepo.vala"
							count_limit = _tmp59_->count_weekly;
#line 714 "Core/SnapshotRepo.vala"
							break;
#line 3951 "SnapshotRepo.c"
						}
					}
				} else if (_tmp47_ == ((0 != _tmp46_label3) ? _tmp46_label3 : (_tmp46_label3 = g_quark_from_static_string ("monthly")))) {
#line 702 "Core/SnapshotRepo.vala"
					switch (0) {
#line 3957 "SnapshotRepo.c"
						default:
						{
							GDateTime* _tmp60_;
							Main* _tmp61_;
							GDateTime* _tmp62_;
							Main* _tmp63_;
#line 716 "Core/SnapshotRepo.vala"
							_tmp60_ = now;
#line 716 "Core/SnapshotRepo.vala"
							_tmp61_ = App;
#line 716 "Core/SnapshotRepo.vala"
							_tmp62_ = g_date_time_add_months (_tmp60_, -1 * _tmp61_->count_monthly);
#line 716 "Core/SnapshotRepo.vala"
							_g_date_time_unref0 (dt_limit);
#line 716 "Core/SnapshotRepo.vala"
							dt_limit = _tmp62_;
#line 717 "Core/SnapshotRepo.vala"
							_tmp63_ = App;
#line 717 "Core/SnapshotRepo.vala"
							count_limit = _tmp63_->count_monthly;
#line 718 "Core/SnapshotRepo.vala"
							break;
#line 3980 "SnapshotRepo.c"
						}
					}
				} else {
#line 702 "Core/SnapshotRepo.vala"
					switch (0) {
#line 3986 "SnapshotRepo.c"
						default:
						{
							GDateTime* _tmp64_;
							GDateTime* _tmp65_;
#line 720 "Core/SnapshotRepo.vala"
							_tmp64_ = now;
#line 720 "Core/SnapshotRepo.vala"
							_tmp65_ = g_date_time_add_years (_tmp64_, -1 * 10);
#line 720 "Core/SnapshotRepo.vala"
							_g_date_time_unref0 (dt_limit);
#line 720 "Core/SnapshotRepo.vala"
							dt_limit = _tmp65_;
#line 721 "Core/SnapshotRepo.vala"
							count_limit = 100000;
#line 722 "Core/SnapshotRepo.vala"
							break;
#line 4003 "SnapshotRepo.c"
						}
					}
				}
#line 725 "Core/SnapshotRepo.vala"
				_tmp66_ = list;
#line 725 "Core/SnapshotRepo.vala"
				_tmp67_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp66_);
#line 725 "Core/SnapshotRepo.vala"
				_tmp68_ = _tmp67_;
#line 725 "Core/SnapshotRepo.vala"
				if (_tmp68_ > count_limit) {
#line 4015 "SnapshotRepo.c"
					const gchar* _tmp69_;
					gchar* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
					gint snaps_count = 0;
					GeeArrayList* _tmp74_;
					gint _tmp75_;
					gint _tmp76_;
#line 727 "Core/SnapshotRepo.vala"
					_tmp69_ = level;
#line 727 "Core/SnapshotRepo.vala"
					_tmp70_ = g_strdup_printf (" '%s'", _tmp69_);
#line 727 "Core/SnapshotRepo.vala"
					_tmp71_ = _tmp70_;
#line 727 "Core/SnapshotRepo.vala"
					_tmp72_ = g_strconcat (_ ("Maximum backups exceeded for backup level"), _tmp71_, NULL);
#line 727 "Core/SnapshotRepo.vala"
					_tmp73_ = _tmp72_;
#line 727 "Core/SnapshotRepo.vala"
					tee_jee_logging_log_msg (_tmp73_, FALSE);
#line 727 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp73_);
#line 727 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp71_);
#line 729 "Core/SnapshotRepo.vala"
					_tmp74_ = list;
#line 729 "Core/SnapshotRepo.vala"
					_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
#line 729 "Core/SnapshotRepo.vala"
					_tmp76_ = _tmp75_;
#line 729 "Core/SnapshotRepo.vala"
					snaps_count = _tmp76_;
#line 4049 "SnapshotRepo.c"
					{
						GeeArrayList* _snap_list = NULL;
						GeeArrayList* _tmp77_;
						gint _snap_size = 0;
						GeeArrayList* _tmp78_;
						gint _tmp79_;
						gint _tmp80_;
						gint _snap_index = 0;
#line 731 "Core/SnapshotRepo.vala"
						_tmp77_ = list;
#line 731 "Core/SnapshotRepo.vala"
						_snap_list = _tmp77_;
#line 731 "Core/SnapshotRepo.vala"
						_tmp78_ = _snap_list;
#line 731 "Core/SnapshotRepo.vala"
						_tmp79_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp78_);
#line 731 "Core/SnapshotRepo.vala"
						_tmp80_ = _tmp79_;
#line 731 "Core/SnapshotRepo.vala"
						_snap_size = _tmp80_;
#line 731 "Core/SnapshotRepo.vala"
						_snap_index = -1;
#line 731 "Core/SnapshotRepo.vala"
						while (TRUE) {
#line 4074 "SnapshotRepo.c"
							gint _tmp81_;
							gint _tmp82_;
							Snapshot* snap = NULL;
							GeeArrayList* _tmp83_;
							gpointer _tmp84_;
							Snapshot* _tmp85_;
							const gchar* _tmp86_;
							gchar* _tmp87_;
							gchar* _tmp88_;
							gint _tmp89_;
							gint _tmp90_;
							gboolean _tmp91_;
							gboolean _tmp92_ = FALSE;
							Snapshot* _tmp93_;
							GDateTime* _tmp94_;
							GDateTime* _tmp95_;
#line 731 "Core/SnapshotRepo.vala"
							_snap_index = _snap_index + 1;
#line 731 "Core/SnapshotRepo.vala"
							_tmp81_ = _snap_index;
#line 731 "Core/SnapshotRepo.vala"
							_tmp82_ = _snap_size;
#line 731 "Core/SnapshotRepo.vala"
							if (!(_tmp81_ < _tmp82_)) {
#line 731 "Core/SnapshotRepo.vala"
								break;
#line 4101 "SnapshotRepo.c"
							}
#line 731 "Core/SnapshotRepo.vala"
							_tmp83_ = _snap_list;
#line 731 "Core/SnapshotRepo.vala"
							_tmp84_ = gee_abstract_list_get ((GeeAbstractList*) _tmp83_, _snap_index);
#line 731 "Core/SnapshotRepo.vala"
							snap = (Snapshot*) _tmp84_;
#line 733 "Core/SnapshotRepo.vala"
							_tmp85_ = snap;
#line 733 "Core/SnapshotRepo.vala"
							_tmp86_ = _tmp85_->description;
#line 733 "Core/SnapshotRepo.vala"
							_tmp87_ = string_strip (_tmp86_);
#line 733 "Core/SnapshotRepo.vala"
							_tmp88_ = _tmp87_;
#line 733 "Core/SnapshotRepo.vala"
							_tmp89_ = strlen (_tmp88_);
#line 733 "Core/SnapshotRepo.vala"
							_tmp90_ = _tmp89_;
#line 733 "Core/SnapshotRepo.vala"
							_tmp91_ = _tmp90_ > 0;
#line 733 "Core/SnapshotRepo.vala"
							_g_free0 (_tmp88_);
#line 733 "Core/SnapshotRepo.vala"
							if (_tmp91_) {
#line 733 "Core/SnapshotRepo.vala"
								_g_object_unref0 (snap);
#line 733 "Core/SnapshotRepo.vala"
								continue;
#line 4131 "SnapshotRepo.c"
							}
#line 735 "Core/SnapshotRepo.vala"
							_tmp93_ = snap;
#line 735 "Core/SnapshotRepo.vala"
							_tmp94_ = _tmp93_->date;
#line 735 "Core/SnapshotRepo.vala"
							_tmp95_ = dt_limit;
#line 735 "Core/SnapshotRepo.vala"
							if (g_date_time_compare (_tmp94_, _tmp95_) < 0) {
#line 735 "Core/SnapshotRepo.vala"
								_tmp92_ = snaps_count > count_limit;
#line 4143 "SnapshotRepo.c"
							} else {
#line 735 "Core/SnapshotRepo.vala"
								_tmp92_ = FALSE;
#line 4147 "SnapshotRepo.c"
							}
#line 735 "Core/SnapshotRepo.vala"
							if (_tmp92_) {
#line 4151 "SnapshotRepo.c"
								Snapshot* _tmp96_;
								const gchar* _tmp97_;
								gint _tmp98_;
								GeeArrayList* _tmp99_;
								gpointer _tmp100_;
								Snapshot* _tmp101_;
								const gchar* _tmp102_;
								gchar* _tmp103_;
								gchar* _tmp104_;
								gchar* _tmp105_;
								gchar* _tmp106_;
								gchar* _tmp107_;
								gchar* _tmp108_;
								const gchar* _tmp109_;
								gchar* _tmp110_;
								gchar* _tmp111_;
								gchar* _tmp112_;
								gchar* _tmp113_;
#line 737 "Core/SnapshotRepo.vala"
								_tmp96_ = snap;
#line 737 "Core/SnapshotRepo.vala"
								_tmp97_ = level;
#line 737 "Core/SnapshotRepo.vala"
								snapshot_remove_tag (_tmp96_, _tmp97_);
#line 738 "Core/SnapshotRepo.vala"
								_tmp98_ = snaps_count;
#line 738 "Core/SnapshotRepo.vala"
								snaps_count = _tmp98_ - 1;
#line 740 "Core/SnapshotRepo.vala"
								_tmp99_ = list;
#line 740 "Core/SnapshotRepo.vala"
								_tmp100_ = gee_abstract_list_get ((GeeAbstractList*) _tmp99_, 0);
#line 740 "Core/SnapshotRepo.vala"
								_tmp101_ = (Snapshot*) _tmp100_;
#line 740 "Core/SnapshotRepo.vala"
								_tmp102_ = _tmp101_->name;
#line 740 "Core/SnapshotRepo.vala"
								_tmp103_ = g_strdup_printf (" '%s' ", _tmp102_);
#line 740 "Core/SnapshotRepo.vala"
								_tmp104_ = _tmp103_;
#line 740 "Core/SnapshotRepo.vala"
								_tmp105_ = g_strconcat (_ ("Snapshot"), _tmp104_, NULL);
#line 740 "Core/SnapshotRepo.vala"
								_tmp106_ = _tmp105_;
#line 740 "Core/SnapshotRepo.vala"
								_tmp107_ = g_strconcat (_tmp106_, _ ("un-tagged"), NULL);
#line 740 "Core/SnapshotRepo.vala"
								_tmp108_ = _tmp107_;
#line 740 "Core/SnapshotRepo.vala"
								_tmp109_ = level;
#line 740 "Core/SnapshotRepo.vala"
								_tmp110_ = g_strdup_printf (" '%s'", _tmp109_);
#line 740 "Core/SnapshotRepo.vala"
								_tmp111_ = _tmp110_;
#line 740 "Core/SnapshotRepo.vala"
								_tmp112_ = g_strconcat (_tmp108_, _tmp111_, NULL);
#line 740 "Core/SnapshotRepo.vala"
								_tmp113_ = _tmp112_;
#line 740 "Core/SnapshotRepo.vala"
								tee_jee_logging_log_msg (_tmp113_, FALSE);
#line 740 "Core/SnapshotRepo.vala"
								_g_free0 (_tmp113_);
#line 740 "Core/SnapshotRepo.vala"
								_g_free0 (_tmp111_);
#line 740 "Core/SnapshotRepo.vala"
								_g_free0 (_tmp108_);
#line 740 "Core/SnapshotRepo.vala"
								_g_free0 (_tmp106_);
#line 740 "Core/SnapshotRepo.vala"
								_g_free0 (_tmp104_);
#line 740 "Core/SnapshotRepo.vala"
								_g_object_unref0 (_tmp101_);
#line 4224 "SnapshotRepo.c"
							}
#line 731 "Core/SnapshotRepo.vala"
							_g_object_unref0 (snap);
#line 4228 "SnapshotRepo.c"
						}
					}
				}
#line 696 "Core/SnapshotRepo.vala"
				_g_free0 (level);
#line 4234 "SnapshotRepo.c"
			}
		}
	}
#line 769 "Core/SnapshotRepo.vala"
	snapshot_repo_remove_untagged (self);
#line 802 "Core/SnapshotRepo.vala"
	snapshot_repo_remove_marked_for_deletion (self);
#line 806 "Core/SnapshotRepo.vala"
	snapshot_repo_remove_invalid (self);
#line 671 "Core/SnapshotRepo.vala"
	levels = (_vala_array_free (levels, levels_length1, (GDestroyNotify) g_free), NULL);
#line 671 "Core/SnapshotRepo.vala"
	_g_object_unref0 (list);
#line 671 "Core/SnapshotRepo.vala"
	_g_date_time_unref0 (dt_limit);
#line 671 "Core/SnapshotRepo.vala"
	_g_date_time_unref0 (now);
#line 4252 "SnapshotRepo.c"
}

void
snapshot_repo_remove_untagged (SnapshotRepo* self)
{
	gboolean show_msg = FALSE;
#line 809 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 811 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug ("SnapshotRepo: remove_untagged()");
#line 813 "Core/SnapshotRepo.vala"
	show_msg = TRUE;
#line 4265 "SnapshotRepo.c"
	{
		GeeArrayList* _bak_list = NULL;
		GeeArrayList* _tmp0_;
		gint _bak_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _bak_index = 0;
#line 815 "Core/SnapshotRepo.vala"
		_tmp0_ = self->snapshots;
#line 815 "Core/SnapshotRepo.vala"
		_bak_list = _tmp0_;
#line 815 "Core/SnapshotRepo.vala"
		_tmp1_ = _bak_list;
#line 815 "Core/SnapshotRepo.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 815 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_;
#line 815 "Core/SnapshotRepo.vala"
		_bak_size = _tmp3_;
#line 815 "Core/SnapshotRepo.vala"
		_bak_index = -1;
#line 815 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 4290 "SnapshotRepo.c"
			gint _tmp4_;
			gint _tmp5_;
			Snapshot* bak = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Snapshot* _tmp8_;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 815 "Core/SnapshotRepo.vala"
			_bak_index = _bak_index + 1;
#line 815 "Core/SnapshotRepo.vala"
			_tmp4_ = _bak_index;
#line 815 "Core/SnapshotRepo.vala"
			_tmp5_ = _bak_size;
#line 815 "Core/SnapshotRepo.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 815 "Core/SnapshotRepo.vala"
				break;
#line 4310 "SnapshotRepo.c"
			}
#line 815 "Core/SnapshotRepo.vala"
			_tmp6_ = _bak_list;
#line 815 "Core/SnapshotRepo.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _bak_index);
#line 815 "Core/SnapshotRepo.vala"
			bak = (Snapshot*) _tmp7_;
#line 816 "Core/SnapshotRepo.vala"
			_tmp8_ = bak;
#line 816 "Core/SnapshotRepo.vala"
			_tmp9_ = _tmp8_->tags;
#line 816 "Core/SnapshotRepo.vala"
			_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 816 "Core/SnapshotRepo.vala"
			_tmp11_ = _tmp10_;
#line 816 "Core/SnapshotRepo.vala"
			if (_tmp11_ == 0) {
#line 4328 "SnapshotRepo.c"
				Snapshot* _tmp14_;
#line 818 "Core/SnapshotRepo.vala"
				if (show_msg) {
#line 4332 "SnapshotRepo.c"
					gchar* _tmp12_;
					gchar* _tmp13_;
#line 819 "Core/SnapshotRepo.vala"
					_tmp12_ = g_strdup_printf ("%s (%s):", _ ("Removing snapshots"), _ ("un-tagged"));
#line 819 "Core/SnapshotRepo.vala"
					_tmp13_ = _tmp12_;
#line 819 "Core/SnapshotRepo.vala"
					tee_jee_logging_log_msg (_tmp13_, FALSE);
#line 819 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp13_);
#line 820 "Core/SnapshotRepo.vala"
					show_msg = FALSE;
#line 4345 "SnapshotRepo.c"
				}
#line 823 "Core/SnapshotRepo.vala"
				_tmp14_ = bak;
#line 823 "Core/SnapshotRepo.vala"
				snapshot_remove (_tmp14_, TRUE);
#line 4351 "SnapshotRepo.c"
			}
#line 815 "Core/SnapshotRepo.vala"
			_g_object_unref0 (bak);
#line 4355 "SnapshotRepo.c"
		}
	}
#line 827 "Core/SnapshotRepo.vala"
	snapshot_repo_load_snapshots (self);
#line 4360 "SnapshotRepo.c"
}

void
snapshot_repo_remove_marked_for_deletion (SnapshotRepo* self)
{
	gboolean show_msg = FALSE;
#line 830 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 832 "Core/SnapshotRepo.vala"
	show_msg = TRUE;
#line 4371 "SnapshotRepo.c"
	{
		GeeArrayList* _bak_list = NULL;
		GeeArrayList* _tmp0_;
		gint _bak_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _bak_index = 0;
#line 834 "Core/SnapshotRepo.vala"
		_tmp0_ = self->snapshots;
#line 834 "Core/SnapshotRepo.vala"
		_bak_list = _tmp0_;
#line 834 "Core/SnapshotRepo.vala"
		_tmp1_ = _bak_list;
#line 834 "Core/SnapshotRepo.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 834 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_;
#line 834 "Core/SnapshotRepo.vala"
		_bak_size = _tmp3_;
#line 834 "Core/SnapshotRepo.vala"
		_bak_index = -1;
#line 834 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 4396 "SnapshotRepo.c"
			gint _tmp4_;
			gint _tmp5_;
			Snapshot* bak = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Snapshot* _tmp8_;
#line 834 "Core/SnapshotRepo.vala"
			_bak_index = _bak_index + 1;
#line 834 "Core/SnapshotRepo.vala"
			_tmp4_ = _bak_index;
#line 834 "Core/SnapshotRepo.vala"
			_tmp5_ = _bak_size;
#line 834 "Core/SnapshotRepo.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 834 "Core/SnapshotRepo.vala"
				break;
#line 4413 "SnapshotRepo.c"
			}
#line 834 "Core/SnapshotRepo.vala"
			_tmp6_ = _bak_list;
#line 834 "Core/SnapshotRepo.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _bak_index);
#line 834 "Core/SnapshotRepo.vala"
			bak = (Snapshot*) _tmp7_;
#line 835 "Core/SnapshotRepo.vala"
			_tmp8_ = bak;
#line 835 "Core/SnapshotRepo.vala"
			if (_tmp8_->marked_for_deletion) {
#line 4425 "SnapshotRepo.c"
				Snapshot* _tmp11_;
#line 837 "Core/SnapshotRepo.vala"
				if (show_msg) {
#line 4429 "SnapshotRepo.c"
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 838 "Core/SnapshotRepo.vala"
					_tmp9_ = g_strdup_printf ("%s (%s):", _ ("Removing snapshots"), _ ("marked for deletion"));
#line 838 "Core/SnapshotRepo.vala"
					_tmp10_ = _tmp9_;
#line 838 "Core/SnapshotRepo.vala"
					tee_jee_logging_log_msg (_tmp10_, FALSE);
#line 838 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp10_);
#line 839 "Core/SnapshotRepo.vala"
					show_msg = FALSE;
#line 4442 "SnapshotRepo.c"
				}
#line 842 "Core/SnapshotRepo.vala"
				_tmp11_ = bak;
#line 842 "Core/SnapshotRepo.vala"
				snapshot_remove (_tmp11_, TRUE);
#line 4448 "SnapshotRepo.c"
			}
#line 834 "Core/SnapshotRepo.vala"
			_g_object_unref0 (bak);
#line 4452 "SnapshotRepo.c"
		}
	}
#line 846 "Core/SnapshotRepo.vala"
	snapshot_repo_load_snapshots (self);
#line 4457 "SnapshotRepo.c"
}

void
snapshot_repo_remove_invalid (SnapshotRepo* self)
{
	gboolean show_msg = FALSE;
#line 849 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 851 "Core/SnapshotRepo.vala"
	show_msg = TRUE;
#line 4468 "SnapshotRepo.c"
	{
		GeeArrayList* _bak_list = NULL;
		GeeArrayList* _tmp0_;
		gint _bak_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _bak_index = 0;
#line 853 "Core/SnapshotRepo.vala"
		_tmp0_ = self->invalid_snapshots;
#line 853 "Core/SnapshotRepo.vala"
		_bak_list = _tmp0_;
#line 853 "Core/SnapshotRepo.vala"
		_tmp1_ = _bak_list;
#line 853 "Core/SnapshotRepo.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 853 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_;
#line 853 "Core/SnapshotRepo.vala"
		_bak_size = _tmp3_;
#line 853 "Core/SnapshotRepo.vala"
		_bak_index = -1;
#line 853 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 4493 "SnapshotRepo.c"
			gint _tmp4_;
			gint _tmp5_;
			Snapshot* bak = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Snapshot* _tmp10_;
#line 853 "Core/SnapshotRepo.vala"
			_bak_index = _bak_index + 1;
#line 853 "Core/SnapshotRepo.vala"
			_tmp4_ = _bak_index;
#line 853 "Core/SnapshotRepo.vala"
			_tmp5_ = _bak_size;
#line 853 "Core/SnapshotRepo.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 853 "Core/SnapshotRepo.vala"
				break;
#line 4510 "SnapshotRepo.c"
			}
#line 853 "Core/SnapshotRepo.vala"
			_tmp6_ = _bak_list;
#line 853 "Core/SnapshotRepo.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _bak_index);
#line 853 "Core/SnapshotRepo.vala"
			bak = (Snapshot*) _tmp7_;
#line 855 "Core/SnapshotRepo.vala"
			if (show_msg) {
#line 4520 "SnapshotRepo.c"
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 856 "Core/SnapshotRepo.vala"
				_tmp8_ = g_strdup_printf ("%s (%s):", _ ("Removing snapshots"), _ ("incomplete"));
#line 856 "Core/SnapshotRepo.vala"
				_tmp9_ = _tmp8_;
#line 856 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_msg (_tmp9_, FALSE);
#line 856 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp9_);
#line 857 "Core/SnapshotRepo.vala"
				show_msg = FALSE;
#line 4533 "SnapshotRepo.c"
			}
#line 860 "Core/SnapshotRepo.vala"
			_tmp10_ = bak;
#line 860 "Core/SnapshotRepo.vala"
			snapshot_remove (_tmp10_, TRUE);
#line 853 "Core/SnapshotRepo.vala"
			_g_object_unref0 (bak);
#line 4541 "SnapshotRepo.c"
		}
	}
#line 863 "Core/SnapshotRepo.vala"
	snapshot_repo_load_snapshots (self);
#line 4546 "SnapshotRepo.c"
}

gboolean
snapshot_repo_remove_all (SnapshotRepo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
#line 866 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 868 "Core/SnapshotRepo.vala"
	_tmp0_ = snapshot_repo_get_timeshift_path (self);
#line 868 "Core/SnapshotRepo.vala"
	_tmp1_ = _tmp0_;
#line 868 "Core/SnapshotRepo.vala"
	_tmp2_ = _tmp1_;
#line 868 "Core/SnapshotRepo.vala"
	_tmp3_ = tee_jee_file_system_dir_exists (_tmp2_);
#line 868 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp2_);
#line 868 "Core/SnapshotRepo.vala"
	if (_tmp3_) {
#line 4571 "SnapshotRepo.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean ok = FALSE;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gboolean _tmp22_;
#line 870 "Core/SnapshotRepo.vala"
		_tmp4_ = g_strconcat (_ ("Removing snapshots"), " > ", NULL);
#line 870 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 870 "Core/SnapshotRepo.vala"
		_tmp6_ = g_strconcat (_tmp5_, _ ("all"), NULL);
#line 870 "Core/SnapshotRepo.vala"
		_tmp7_ = _tmp6_;
#line 870 "Core/SnapshotRepo.vala"
		_tmp8_ = g_strconcat (_tmp7_, "...", NULL);
#line 870 "Core/SnapshotRepo.vala"
		_tmp9_ = _tmp8_;
#line 870 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp9_, FALSE);
#line 870 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp9_);
#line 870 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp7_);
#line 870 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp5_);
#line 4603 "SnapshotRepo.c"
		{
			GeeArrayList* _bak_list = NULL;
			GeeArrayList* _tmp10_;
			gint _bak_size = 0;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _bak_index = 0;
#line 873 "Core/SnapshotRepo.vala"
			_tmp10_ = self->snapshots;
#line 873 "Core/SnapshotRepo.vala"
			_bak_list = _tmp10_;
#line 873 "Core/SnapshotRepo.vala"
			_tmp11_ = _bak_list;
#line 873 "Core/SnapshotRepo.vala"
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 873 "Core/SnapshotRepo.vala"
			_tmp13_ = _tmp12_;
#line 873 "Core/SnapshotRepo.vala"
			_bak_size = _tmp13_;
#line 873 "Core/SnapshotRepo.vala"
			_bak_index = -1;
#line 873 "Core/SnapshotRepo.vala"
			while (TRUE) {
#line 4628 "SnapshotRepo.c"
				gint _tmp14_;
				gint _tmp15_;
				Snapshot* bak = NULL;
				GeeArrayList* _tmp16_;
				gpointer _tmp17_;
				Snapshot* _tmp18_;
#line 873 "Core/SnapshotRepo.vala"
				_bak_index = _bak_index + 1;
#line 873 "Core/SnapshotRepo.vala"
				_tmp14_ = _bak_index;
#line 873 "Core/SnapshotRepo.vala"
				_tmp15_ = _bak_size;
#line 873 "Core/SnapshotRepo.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 873 "Core/SnapshotRepo.vala"
					break;
#line 4645 "SnapshotRepo.c"
				}
#line 873 "Core/SnapshotRepo.vala"
				_tmp16_ = _bak_list;
#line 873 "Core/SnapshotRepo.vala"
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _bak_index);
#line 873 "Core/SnapshotRepo.vala"
				bak = (Snapshot*) _tmp17_;
#line 874 "Core/SnapshotRepo.vala"
				_tmp18_ = bak;
#line 874 "Core/SnapshotRepo.vala"
				snapshot_remove (_tmp18_, TRUE);
#line 873 "Core/SnapshotRepo.vala"
				_g_object_unref0 (bak);
#line 4659 "SnapshotRepo.c"
			}
		}
#line 877 "Core/SnapshotRepo.vala"
		snapshot_repo_remove_sync_dir (self);
#line 879 "Core/SnapshotRepo.vala"
		_tmp19_ = snapshot_repo_get_timeshift_path (self);
#line 879 "Core/SnapshotRepo.vala"
		_tmp20_ = _tmp19_;
#line 879 "Core/SnapshotRepo.vala"
		_tmp21_ = _tmp20_;
#line 879 "Core/SnapshotRepo.vala"
		_tmp22_ = snapshot_repo_delete_directory (self, _tmp21_);
#line 879 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp21_);
#line 879 "Core/SnapshotRepo.vala"
		ok = _tmp22_;
#line 881 "Core/SnapshotRepo.vala"
		snapshot_repo_load_snapshots (self);
#line 883 "Core/SnapshotRepo.vala"
		result = ok;
#line 883 "Core/SnapshotRepo.vala"
		return result;
#line 4682 "SnapshotRepo.c"
	} else {
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 886 "Core/SnapshotRepo.vala"
		_tmp23_ = self->mount_path;
#line 886 "Core/SnapshotRepo.vala"
		_tmp24_ = g_strdup_printf (" '%s'", _tmp23_);
#line 886 "Core/SnapshotRepo.vala"
		_tmp25_ = _tmp24_;
#line 886 "Core/SnapshotRepo.vala"
		_tmp26_ = g_strconcat (_ ("No snapshots found"), _tmp25_, NULL);
#line 886 "Core/SnapshotRepo.vala"
		_tmp27_ = _tmp26_;
#line 886 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_msg (_tmp27_, FALSE);
#line 886 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp27_);
#line 886 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp25_);
#line 887 "Core/SnapshotRepo.vala"
		result = TRUE;
#line 887 "Core/SnapshotRepo.vala"
		return result;
#line 4709 "SnapshotRepo.c"
	}
}

gboolean
snapshot_repo_remove_sync_dir (SnapshotRepo* self)
{
	gchar* sync_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result = FALSE;
#line 891 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 892 "Core/SnapshotRepo.vala"
	_tmp0_ = self->mount_path;
#line 892 "Core/SnapshotRepo.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/timeshift/snapshots/.sync", NULL);
#line 892 "Core/SnapshotRepo.vala"
	sync_dir = _tmp1_;
#line 895 "Core/SnapshotRepo.vala"
	_tmp2_ = sync_dir;
#line 895 "Core/SnapshotRepo.vala"
	if (tee_jee_file_system_dir_exists (_tmp2_)) {
#line 4733 "SnapshotRepo.c"
		const gchar* _tmp3_;
#line 896 "Core/SnapshotRepo.vala"
		_tmp3_ = sync_dir;
#line 896 "Core/SnapshotRepo.vala"
		if (!snapshot_repo_delete_directory (self, _tmp3_)) {
#line 897 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 897 "Core/SnapshotRepo.vala"
			_g_free0 (sync_dir);
#line 897 "Core/SnapshotRepo.vala"
			return result;
#line 4745 "SnapshotRepo.c"
		}
	}
#line 901 "Core/SnapshotRepo.vala"
	result = TRUE;
#line 901 "Core/SnapshotRepo.vala"
	_g_free0 (sync_dir);
#line 901 "Core/SnapshotRepo.vala"
	return result;
#line 4754 "SnapshotRepo.c"
}

gboolean
snapshot_repo_remove_timeshift_dir (SnapshotRepo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
#line 904 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 907 "Core/SnapshotRepo.vala"
	_tmp0_ = snapshot_repo_get_timeshift_path (self);
#line 907 "Core/SnapshotRepo.vala"
	_tmp1_ = _tmp0_;
#line 907 "Core/SnapshotRepo.vala"
	_tmp2_ = _tmp1_;
#line 907 "Core/SnapshotRepo.vala"
	_tmp3_ = tee_jee_file_system_dir_exists (_tmp2_);
#line 907 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp2_);
#line 907 "Core/SnapshotRepo.vala"
	if (_tmp3_) {
#line 4779 "SnapshotRepo.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
#line 908 "Core/SnapshotRepo.vala"
		_tmp4_ = snapshot_repo_get_timeshift_path (self);
#line 908 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 908 "Core/SnapshotRepo.vala"
		_tmp6_ = _tmp5_;
#line 908 "Core/SnapshotRepo.vala"
		_tmp7_ = !snapshot_repo_delete_directory (self, _tmp6_);
#line 908 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp6_);
#line 908 "Core/SnapshotRepo.vala"
		if (_tmp7_) {
#line 909 "Core/SnapshotRepo.vala"
			result = FALSE;
#line 909 "Core/SnapshotRepo.vala"
			return result;
#line 4800 "SnapshotRepo.c"
		}
	}
#line 913 "Core/SnapshotRepo.vala"
	result = TRUE;
#line 913 "Core/SnapshotRepo.vala"
	return result;
#line 4807 "SnapshotRepo.c"
}

static gpointer
_snapshot_repo_delete_directory_thread_gthread_func (gpointer self)
{
	gpointer result;
#line 924 "Core/SnapshotRepo.vala"
	snapshot_repo_delete_directory_thread ((SnapshotRepo*) self);
#line 4816 "SnapshotRepo.c"
	result = NULL;
#line 924 "Core/SnapshotRepo.vala"
	g_object_unref (self);
#line 924 "Core/SnapshotRepo.vala"
	return result;
#line 4822 "SnapshotRepo.c"
}

static gboolean
snapshot_repo_delete_directory (SnapshotRepo* self,
                                const gchar* dir_path)
{
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 918 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 918 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 919 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup (dir_path);
#line 919 "Core/SnapshotRepo.vala"
	_g_free0 (self->priv->thr_args1);
#line 919 "Core/SnapshotRepo.vala"
	self->priv->thr_args1 = _tmp0_;
#line 4842 "SnapshotRepo.c"
	{
#line 922 "Core/SnapshotRepo.vala"
		self->priv->thr_running = TRUE;
#line 923 "Core/SnapshotRepo.vala"
		self->priv->thr_success = FALSE;
#line 924 "Core/SnapshotRepo.vala"
		g_thread_create (_snapshot_repo_delete_directory_thread_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 924 "Core/SnapshotRepo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4852 "SnapshotRepo.c"
			gboolean _tmp1_ = FALSE;
#line 924 "Core/SnapshotRepo.vala"
			if (_inner_error0_->domain == G_THREAD_ERROR) {
#line 4856 "SnapshotRepo.c"
				goto __catch0_g_thread_error;
			}
#line 924 "Core/SnapshotRepo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 924 "Core/SnapshotRepo.vala"
			g_clear_error (&_inner_error0_);
#line 924 "Core/SnapshotRepo.vala"
			return _tmp1_;
#line 4865 "SnapshotRepo.c"
		}
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 921 "Core/SnapshotRepo.vala"
		e = _inner_error0_;
#line 921 "Core/SnapshotRepo.vala"
		_inner_error0_ = NULL;
#line 926 "Core/SnapshotRepo.vala"
		self->priv->thr_running = FALSE;
#line 927 "Core/SnapshotRepo.vala"
		self->priv->thr_success = FALSE;
#line 928 "Core/SnapshotRepo.vala"
		_tmp2_ = e;
#line 928 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_->message;
#line 928 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 921 "Core/SnapshotRepo.vala"
		_g_error_free0 (e);
#line 4890 "SnapshotRepo.c"
	}
	__finally0:
#line 921 "Core/SnapshotRepo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4895 "SnapshotRepo.c"
		gboolean _tmp4_ = FALSE;
#line 921 "Core/SnapshotRepo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 921 "Core/SnapshotRepo.vala"
		g_clear_error (&_inner_error0_);
#line 921 "Core/SnapshotRepo.vala"
		return _tmp4_;
#line 4903 "SnapshotRepo.c"
	}
#line 931 "Core/SnapshotRepo.vala"
	while (TRUE) {
#line 931 "Core/SnapshotRepo.vala"
		if (!self->priv->thr_running) {
#line 931 "Core/SnapshotRepo.vala"
			break;
#line 4911 "SnapshotRepo.c"
		}
#line 932 "Core/SnapshotRepo.vala"
		tee_jee_gtk_helper_gtk_do_events ();
#line 933 "Core/SnapshotRepo.vala"
		g_usleep (((gulong) G_TIME_SPAN_MILLISECOND) * 100);
#line 4917 "SnapshotRepo.c"
	}
#line 936 "Core/SnapshotRepo.vala"
	_g_free0 (self->priv->thr_args1);
#line 936 "Core/SnapshotRepo.vala"
	self->priv->thr_args1 = NULL;
#line 938 "Core/SnapshotRepo.vala"
	result = self->priv->thr_success;
#line 938 "Core/SnapshotRepo.vala"
	return result;
#line 4927 "SnapshotRepo.c"
}

static void
snapshot_repo_delete_directory_thread (SnapshotRepo* self)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
#line 941 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 942 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup ("");
#line 942 "Core/SnapshotRepo.vala"
	cmd = _tmp0_;
#line 4945 "SnapshotRepo.c"
	{
		GFile* f = NULL;
		const gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 948 "Core/SnapshotRepo.vala"
		_tmp1_ = self->priv->thr_args1;
#line 948 "Core/SnapshotRepo.vala"
		_tmp2_ = g_file_new_for_path (_tmp1_);
#line 948 "Core/SnapshotRepo.vala"
		f = _tmp2_;
#line 949 "Core/SnapshotRepo.vala"
		_tmp3_ = f;
#line 949 "Core/SnapshotRepo.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 4961 "SnapshotRepo.c"
			const gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gint _tmp10_ = 0;
#line 950 "Core/SnapshotRepo.vala"
			_tmp4_ = self->priv->thr_args1;
#line 950 "Core/SnapshotRepo.vala"
			_tmp5_ = g_strdup_printf ("rm -rf \"%s\"", _tmp4_);
#line 950 "Core/SnapshotRepo.vala"
			_g_free0 (cmd);
#line 950 "Core/SnapshotRepo.vala"
			cmd = _tmp5_;
#line 952 "Core/SnapshotRepo.vala"
			if (tee_jee_logging_LOG_COMMANDS) {
#line 4978 "SnapshotRepo.c"
				const gchar* _tmp6_;
#line 952 "Core/SnapshotRepo.vala"
				_tmp6_ = cmd;
#line 952 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_debug (_tmp6_);
#line 4984 "SnapshotRepo.c"
			}
#line 954 "Core/SnapshotRepo.vala"
			_tmp7_ = cmd;
#line 954 "Core/SnapshotRepo.vala"
			g_spawn_command_line_sync (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_inner_error0_);
#line 954 "Core/SnapshotRepo.vala"
			_g_free0 (std_out);
#line 954 "Core/SnapshotRepo.vala"
			std_out = _tmp8_;
#line 954 "Core/SnapshotRepo.vala"
			_g_free0 (std_err);
#line 954 "Core/SnapshotRepo.vala"
			std_err = _tmp9_;
#line 954 "Core/SnapshotRepo.vala"
			ret_val = _tmp10_;
#line 954 "Core/SnapshotRepo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 954 "Core/SnapshotRepo.vala"
				_g_object_unref0 (f);
#line 5004 "SnapshotRepo.c"
				goto __catch0_g_error;
			}
#line 956 "Core/SnapshotRepo.vala"
			if (ret_val != 0) {
#line 5009 "SnapshotRepo.c"
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 957 "Core/SnapshotRepo.vala"
				_tmp11_ = self->priv->thr_args1;
#line 957 "Core/SnapshotRepo.vala"
				_tmp12_ = g_strdup_printf (": '%s'", _tmp11_);
#line 957 "Core/SnapshotRepo.vala"
				_tmp13_ = _tmp12_;
#line 957 "Core/SnapshotRepo.vala"
				_tmp14_ = g_strconcat (_ ("Failed to remove"), _tmp13_, NULL);
#line 957 "Core/SnapshotRepo.vala"
				_tmp15_ = _tmp14_;
#line 957 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 957 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp15_);
#line 957 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp13_);
#line 958 "Core/SnapshotRepo.vala"
				self->priv->thr_success = FALSE;
#line 959 "Core/SnapshotRepo.vala"
				self->priv->thr_running = FALSE;
#line 960 "Core/SnapshotRepo.vala"
				_g_object_unref0 (f);
#line 960 "Core/SnapshotRepo.vala"
				_g_free0 (std_err);
#line 960 "Core/SnapshotRepo.vala"
				_g_free0 (std_out);
#line 960 "Core/SnapshotRepo.vala"
				_g_free0 (cmd);
#line 960 "Core/SnapshotRepo.vala"
				return;
#line 5045 "SnapshotRepo.c"
			} else {
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 963 "Core/SnapshotRepo.vala"
				_tmp16_ = self->priv->thr_args1;
#line 963 "Core/SnapshotRepo.vala"
				_tmp17_ = g_strdup_printf (": '%s'", _tmp16_);
#line 963 "Core/SnapshotRepo.vala"
				_tmp18_ = _tmp17_;
#line 963 "Core/SnapshotRepo.vala"
				_tmp19_ = g_strconcat (_ ("Removed"), _tmp18_, NULL);
#line 963 "Core/SnapshotRepo.vala"
				_tmp20_ = _tmp19_;
#line 963 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_msg (_tmp20_, FALSE);
#line 963 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp20_);
#line 963 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp18_);
#line 964 "Core/SnapshotRepo.vala"
				self->priv->thr_success = TRUE;
#line 965 "Core/SnapshotRepo.vala"
				self->priv->thr_running = FALSE;
#line 966 "Core/SnapshotRepo.vala"
				_g_object_unref0 (f);
#line 966 "Core/SnapshotRepo.vala"
				_g_free0 (std_err);
#line 966 "Core/SnapshotRepo.vala"
				_g_free0 (std_out);
#line 966 "Core/SnapshotRepo.vala"
				_g_free0 (cmd);
#line 966 "Core/SnapshotRepo.vala"
				return;
#line 5082 "SnapshotRepo.c"
			}
		} else {
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 970 "Core/SnapshotRepo.vala"
			_tmp21_ = self->priv->thr_args1;
#line 970 "Core/SnapshotRepo.vala"
			_tmp22_ = g_strdup_printf (": '%s'", _tmp21_);
#line 970 "Core/SnapshotRepo.vala"
			_tmp23_ = _tmp22_;
#line 970 "Core/SnapshotRepo.vala"
			_tmp24_ = g_strconcat (_ ("Directory not found"), _tmp23_, NULL);
#line 970 "Core/SnapshotRepo.vala"
			_tmp25_ = _tmp24_;
#line 970 "Core/SnapshotRepo.vala"
			tee_jee_logging_log_error (_tmp25_, FALSE, FALSE);
#line 970 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp25_);
#line 970 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp23_);
#line 971 "Core/SnapshotRepo.vala"
			self->priv->thr_success = TRUE;
#line 972 "Core/SnapshotRepo.vala"
			self->priv->thr_running = FALSE;
#line 5110 "SnapshotRepo.c"
		}
#line 947 "Core/SnapshotRepo.vala"
		_g_object_unref0 (f);
#line 5114 "SnapshotRepo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp26_;
		const gchar* _tmp27_;
#line 947 "Core/SnapshotRepo.vala"
		e = _inner_error0_;
#line 947 "Core/SnapshotRepo.vala"
		_inner_error0_ = NULL;
#line 976 "Core/SnapshotRepo.vala"
		_tmp26_ = e;
#line 976 "Core/SnapshotRepo.vala"
		_tmp27_ = _tmp26_->message;
#line 976 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_error (_tmp27_, FALSE, FALSE);
#line 977 "Core/SnapshotRepo.vala"
		self->priv->thr_success = FALSE;
#line 978 "Core/SnapshotRepo.vala"
		self->priv->thr_running = FALSE;
#line 979 "Core/SnapshotRepo.vala"
		_g_error_free0 (e);
#line 979 "Core/SnapshotRepo.vala"
		_g_free0 (std_err);
#line 979 "Core/SnapshotRepo.vala"
		_g_free0 (std_out);
#line 979 "Core/SnapshotRepo.vala"
		_g_free0 (cmd);
#line 979 "Core/SnapshotRepo.vala"
		return;
#line 5146 "SnapshotRepo.c"
	}
	__finally0:
#line 947 "Core/SnapshotRepo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 947 "Core/SnapshotRepo.vala"
		_g_free0 (std_err);
#line 947 "Core/SnapshotRepo.vala"
		_g_free0 (std_out);
#line 947 "Core/SnapshotRepo.vala"
		_g_free0 (cmd);
#line 947 "Core/SnapshotRepo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 947 "Core/SnapshotRepo.vala"
		g_clear_error (&_inner_error0_);
#line 947 "Core/SnapshotRepo.vala"
		return;
#line 5163 "SnapshotRepo.c"
	}
#line 941 "Core/SnapshotRepo.vala"
	_g_free0 (std_err);
#line 941 "Core/SnapshotRepo.vala"
	_g_free0 (std_out);
#line 941 "Core/SnapshotRepo.vala"
	_g_free0 (cmd);
#line 5171 "SnapshotRepo.c"
}

void
snapshot_repo_create_symlinks (SnapshotRepo* self)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* path = NULL;
#line 985 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 986 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup ("");
#line 986 "Core/SnapshotRepo.vala"
	cmd = _tmp0_;
#line 991 "Core/SnapshotRepo.vala"
	snapshot_repo_cleanup_symlink_dir (self, "boot");
#line 992 "Core/SnapshotRepo.vala"
	snapshot_repo_cleanup_symlink_dir (self, "hourly");
#line 993 "Core/SnapshotRepo.vala"
	snapshot_repo_cleanup_symlink_dir (self, "daily");
#line 994 "Core/SnapshotRepo.vala"
	snapshot_repo_cleanup_symlink_dir (self, "weekly");
#line 995 "Core/SnapshotRepo.vala"
	snapshot_repo_cleanup_symlink_dir (self, "monthly");
#line 996 "Core/SnapshotRepo.vala"
	snapshot_repo_cleanup_symlink_dir (self, "ondemand");
#line 5201 "SnapshotRepo.c"
	{
		GeeArrayList* _bak_list = NULL;
		GeeArrayList* _tmp1_;
		gint _bak_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _bak_index = 0;
#line 1000 "Core/SnapshotRepo.vala"
		_tmp1_ = self->snapshots;
#line 1000 "Core/SnapshotRepo.vala"
		_bak_list = _tmp1_;
#line 1000 "Core/SnapshotRepo.vala"
		_tmp2_ = _bak_list;
#line 1000 "Core/SnapshotRepo.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1000 "Core/SnapshotRepo.vala"
		_tmp4_ = _tmp3_;
#line 1000 "Core/SnapshotRepo.vala"
		_bak_size = _tmp4_;
#line 1000 "Core/SnapshotRepo.vala"
		_bak_index = -1;
#line 1000 "Core/SnapshotRepo.vala"
		while (TRUE) {
#line 5226 "SnapshotRepo.c"
			gint _tmp5_;
			gint _tmp6_;
			Snapshot* bak = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
#line 1000 "Core/SnapshotRepo.vala"
			_bak_index = _bak_index + 1;
#line 1000 "Core/SnapshotRepo.vala"
			_tmp5_ = _bak_index;
#line 1000 "Core/SnapshotRepo.vala"
			_tmp6_ = _bak_size;
#line 1000 "Core/SnapshotRepo.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1000 "Core/SnapshotRepo.vala"
				break;
#line 5242 "SnapshotRepo.c"
			}
#line 1000 "Core/SnapshotRepo.vala"
			_tmp7_ = _bak_list;
#line 1000 "Core/SnapshotRepo.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _bak_index);
#line 1000 "Core/SnapshotRepo.vala"
			bak = (Snapshot*) _tmp8_;
#line 5250 "SnapshotRepo.c"
			{
				GeeArrayList* _tag_list = NULL;
				Snapshot* _tmp9_;
				GeeArrayList* _tmp10_;
				gint _tag_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _tag_index = 0;
#line 1001 "Core/SnapshotRepo.vala"
				_tmp9_ = bak;
#line 1001 "Core/SnapshotRepo.vala"
				_tmp10_ = _tmp9_->tags;
#line 1001 "Core/SnapshotRepo.vala"
				_tag_list = _tmp10_;
#line 1001 "Core/SnapshotRepo.vala"
				_tmp11_ = _tag_list;
#line 1001 "Core/SnapshotRepo.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1001 "Core/SnapshotRepo.vala"
				_tmp13_ = _tmp12_;
#line 1001 "Core/SnapshotRepo.vala"
				_tag_size = _tmp13_;
#line 1001 "Core/SnapshotRepo.vala"
				_tag_index = -1;
#line 1001 "Core/SnapshotRepo.vala"
				while (TRUE) {
#line 5278 "SnapshotRepo.c"
					gint _tmp14_;
					gint _tmp15_;
					gchar* tag = NULL;
					GeeArrayList* _tmp16_;
					gpointer _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					Snapshot* _tmp23_;
					const gchar* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp28_;
					gchar* _tmp29_ = NULL;
					gchar* _tmp30_ = NULL;
					gint _tmp31_;
#line 1001 "Core/SnapshotRepo.vala"
					_tag_index = _tag_index + 1;
#line 1001 "Core/SnapshotRepo.vala"
					_tmp14_ = _tag_index;
#line 1001 "Core/SnapshotRepo.vala"
					_tmp15_ = _tag_size;
#line 1001 "Core/SnapshotRepo.vala"
					if (!(_tmp14_ < _tmp15_)) {
#line 1001 "Core/SnapshotRepo.vala"
						break;
#line 5307 "SnapshotRepo.c"
					}
#line 1001 "Core/SnapshotRepo.vala"
					_tmp16_ = _tag_list;
#line 1001 "Core/SnapshotRepo.vala"
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _tag_index);
#line 1001 "Core/SnapshotRepo.vala"
					tag = (gchar*) _tmp17_;
#line 1003 "Core/SnapshotRepo.vala"
					_tmp18_ = snapshot_repo_get_snapshots_path (self);
#line 1003 "Core/SnapshotRepo.vala"
					_tmp19_ = _tmp18_;
#line 1003 "Core/SnapshotRepo.vala"
					_tmp20_ = _tmp19_;
#line 1003 "Core/SnapshotRepo.vala"
					_tmp21_ = tag;
#line 1003 "Core/SnapshotRepo.vala"
					_tmp22_ = g_strdup_printf ("%s-%s", _tmp20_, _tmp21_);
#line 1003 "Core/SnapshotRepo.vala"
					_g_free0 (path);
#line 1003 "Core/SnapshotRepo.vala"
					path = _tmp22_;
#line 1003 "Core/SnapshotRepo.vala"
					_g_free0 (_tmp20_);
#line 1004 "Core/SnapshotRepo.vala"
					_tmp23_ = bak;
#line 1004 "Core/SnapshotRepo.vala"
					_tmp24_ = _tmp23_->name;
#line 1004 "Core/SnapshotRepo.vala"
					_tmp25_ = path;
#line 1004 "Core/SnapshotRepo.vala"
					_tmp26_ = g_strdup_printf ("ln --symbolic \"../snapshots/%s\" -t \"%s\"", _tmp24_, _tmp25_);
#line 1004 "Core/SnapshotRepo.vala"
					_g_free0 (cmd);
#line 1004 "Core/SnapshotRepo.vala"
					cmd = _tmp26_;
#line 1006 "Core/SnapshotRepo.vala"
					if (tee_jee_logging_LOG_COMMANDS) {
#line 5345 "SnapshotRepo.c"
						const gchar* _tmp27_;
#line 1006 "Core/SnapshotRepo.vala"
						_tmp27_ = cmd;
#line 1006 "Core/SnapshotRepo.vala"
						tee_jee_logging_log_debug (_tmp27_);
#line 5351 "SnapshotRepo.c"
					}
#line 1008 "Core/SnapshotRepo.vala"
					_tmp28_ = cmd;
#line 1008 "Core/SnapshotRepo.vala"
					_tmp31_ = tee_jee_process_helper_exec_sync (_tmp28_, &_tmp29_, &_tmp30_);
#line 1008 "Core/SnapshotRepo.vala"
					_g_free0 (std_out);
#line 1008 "Core/SnapshotRepo.vala"
					std_out = _tmp29_;
#line 1008 "Core/SnapshotRepo.vala"
					_g_free0 (std_err);
#line 1008 "Core/SnapshotRepo.vala"
					std_err = _tmp30_;
#line 1008 "Core/SnapshotRepo.vala"
					ret_val = _tmp31_;
#line 1009 "Core/SnapshotRepo.vala"
					if (ret_val != 0) {
#line 5369 "SnapshotRepo.c"
						const gchar* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
#line 1010 "Core/SnapshotRepo.vala"
						_tmp32_ = std_err;
#line 1010 "Core/SnapshotRepo.vala"
						tee_jee_logging_log_error (_tmp32_, FALSE, FALSE);
#line 1011 "Core/SnapshotRepo.vala"
						_tmp33_ = tag;
#line 1011 "Core/SnapshotRepo.vala"
						_tmp34_ = g_strdup_printf (": snapshots-%s", _tmp33_);
#line 1011 "Core/SnapshotRepo.vala"
						_tmp35_ = _tmp34_;
#line 1011 "Core/SnapshotRepo.vala"
						_tmp36_ = g_strconcat (_ ("Failed to create symlinks"), _tmp35_, NULL);
#line 1011 "Core/SnapshotRepo.vala"
						_tmp37_ = _tmp36_;
#line 1011 "Core/SnapshotRepo.vala"
						tee_jee_logging_log_error (_tmp37_, FALSE, FALSE);
#line 1011 "Core/SnapshotRepo.vala"
						_g_free0 (_tmp37_);
#line 1011 "Core/SnapshotRepo.vala"
						_g_free0 (_tmp35_);
#line 1012 "Core/SnapshotRepo.vala"
						_g_free0 (tag);
#line 1012 "Core/SnapshotRepo.vala"
						_g_object_unref0 (bak);
#line 1012 "Core/SnapshotRepo.vala"
						_g_free0 (path);
#line 1012 "Core/SnapshotRepo.vala"
						_g_free0 (std_err);
#line 1012 "Core/SnapshotRepo.vala"
						_g_free0 (std_out);
#line 1012 "Core/SnapshotRepo.vala"
						_g_free0 (cmd);
#line 1012 "Core/SnapshotRepo.vala"
						return;
#line 5410 "SnapshotRepo.c"
					}
#line 1001 "Core/SnapshotRepo.vala"
					_g_free0 (tag);
#line 5414 "SnapshotRepo.c"
				}
			}
#line 1000 "Core/SnapshotRepo.vala"
			_g_object_unref0 (bak);
#line 5419 "SnapshotRepo.c"
		}
	}
#line 1017 "Core/SnapshotRepo.vala"
	tee_jee_logging_log_debug (_ ("Symlinks updated"));
#line 985 "Core/SnapshotRepo.vala"
	_g_free0 (path);
#line 985 "Core/SnapshotRepo.vala"
	_g_free0 (std_err);
#line 985 "Core/SnapshotRepo.vala"
	_g_free0 (std_out);
#line 985 "Core/SnapshotRepo.vala"
	_g_free0 (cmd);
#line 5432 "SnapshotRepo.c"
}

void
snapshot_repo_cleanup_symlink_dir (SnapshotRepo* self,
                                   const gchar* tag)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
#line 1020 "Core/SnapshotRepo.vala"
	g_return_if_fail (self != NULL);
#line 1020 "Core/SnapshotRepo.vala"
	g_return_if_fail (tag != NULL);
#line 1021 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup ("");
#line 1021 "Core/SnapshotRepo.vala"
	cmd = _tmp0_;
#line 5453 "SnapshotRepo.c"
	{
		gchar* path = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GFile* f = NULL;
		const gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp23_;
#line 1027 "Core/SnapshotRepo.vala"
		_tmp1_ = snapshot_repo_get_snapshots_path (self);
#line 1027 "Core/SnapshotRepo.vala"
		_tmp2_ = _tmp1_;
#line 1027 "Core/SnapshotRepo.vala"
		_tmp3_ = _tmp2_;
#line 1027 "Core/SnapshotRepo.vala"
		_tmp4_ = g_strdup_printf ("%s-%s", _tmp3_, tag);
#line 1027 "Core/SnapshotRepo.vala"
		_tmp5_ = _tmp4_;
#line 1027 "Core/SnapshotRepo.vala"
		_g_free0 (_tmp3_);
#line 1027 "Core/SnapshotRepo.vala"
		path = _tmp5_;
#line 1028 "Core/SnapshotRepo.vala"
		_tmp6_ = path;
#line 1028 "Core/SnapshotRepo.vala"
		_tmp7_ = g_file_new_for_path (_tmp6_);
#line 1028 "Core/SnapshotRepo.vala"
		f = _tmp7_;
#line 1029 "Core/SnapshotRepo.vala"
		_tmp8_ = f;
#line 1029 "Core/SnapshotRepo.vala"
		if (g_file_query_exists (_tmp8_, NULL)) {
#line 5490 "SnapshotRepo.c"
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp14_;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			gint _tmp17_ = 0;
#line 1030 "Core/SnapshotRepo.vala"
			_tmp9_ = path;
#line 1030 "Core/SnapshotRepo.vala"
			_tmp10_ = g_strconcat (_tmp9_, "/", NULL);
#line 1030 "Core/SnapshotRepo.vala"
			_tmp11_ = _tmp10_;
#line 1030 "Core/SnapshotRepo.vala"
			_tmp12_ = g_strdup_printf ("rm -rf \"%s\"", _tmp11_);
#line 1030 "Core/SnapshotRepo.vala"
			_g_free0 (cmd);
#line 1030 "Core/SnapshotRepo.vala"
			cmd = _tmp12_;
#line 1030 "Core/SnapshotRepo.vala"
			_g_free0 (_tmp11_);
#line 1032 "Core/SnapshotRepo.vala"
			if (tee_jee_logging_LOG_COMMANDS) {
#line 5515 "SnapshotRepo.c"
				const gchar* _tmp13_;
#line 1032 "Core/SnapshotRepo.vala"
				_tmp13_ = cmd;
#line 1032 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_debug (_tmp13_);
#line 5521 "SnapshotRepo.c"
			}
#line 1034 "Core/SnapshotRepo.vala"
			_tmp14_ = cmd;
#line 1034 "Core/SnapshotRepo.vala"
			g_spawn_command_line_sync (_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_, &_inner_error0_);
#line 1034 "Core/SnapshotRepo.vala"
			_g_free0 (std_out);
#line 1034 "Core/SnapshotRepo.vala"
			std_out = _tmp15_;
#line 1034 "Core/SnapshotRepo.vala"
			_g_free0 (std_err);
#line 1034 "Core/SnapshotRepo.vala"
			std_err = _tmp16_;
#line 1034 "Core/SnapshotRepo.vala"
			ret_val = _tmp17_;
#line 1034 "Core/SnapshotRepo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1034 "Core/SnapshotRepo.vala"
				_g_object_unref0 (f);
#line 1034 "Core/SnapshotRepo.vala"
				_g_free0 (path);
#line 5543 "SnapshotRepo.c"
				goto __catch0_g_error;
			}
#line 1035 "Core/SnapshotRepo.vala"
			if (ret_val != 0) {
#line 5548 "SnapshotRepo.c"
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
#line 1036 "Core/SnapshotRepo.vala"
				_tmp18_ = std_err;
#line 1036 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 1037 "Core/SnapshotRepo.vala"
				_tmp19_ = g_strdup_printf (": 'snapshots-%s'", tag);
#line 1037 "Core/SnapshotRepo.vala"
				_tmp20_ = _tmp19_;
#line 1037 "Core/SnapshotRepo.vala"
				_tmp21_ = g_strconcat (_ ("Failed to delete symlinks"), _tmp20_, NULL);
#line 1037 "Core/SnapshotRepo.vala"
				_tmp22_ = _tmp21_;
#line 1037 "Core/SnapshotRepo.vala"
				tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 1037 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp22_);
#line 1037 "Core/SnapshotRepo.vala"
				_g_free0 (_tmp20_);
#line 1038 "Core/SnapshotRepo.vala"
				_g_object_unref0 (f);
#line 1038 "Core/SnapshotRepo.vala"
				_g_free0 (path);
#line 1038 "Core/SnapshotRepo.vala"
				_g_free0 (std_err);
#line 1038 "Core/SnapshotRepo.vala"
				_g_free0 (std_out);
#line 1038 "Core/SnapshotRepo.vala"
				_g_free0 (cmd);
#line 1038 "Core/SnapshotRepo.vala"
				return;
#line 5584 "SnapshotRepo.c"
			}
		}
#line 1042 "Core/SnapshotRepo.vala"
		_tmp23_ = f;
#line 1042 "Core/SnapshotRepo.vala"
		g_file_make_directory_with_parents (_tmp23_, NULL, &_inner_error0_);
#line 1042 "Core/SnapshotRepo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1042 "Core/SnapshotRepo.vala"
			_g_object_unref0 (f);
#line 1042 "Core/SnapshotRepo.vala"
			_g_free0 (path);
#line 5597 "SnapshotRepo.c"
			goto __catch0_g_error;
		}
#line 1026 "Core/SnapshotRepo.vala"
		_g_object_unref0 (f);
#line 1026 "Core/SnapshotRepo.vala"
		_g_free0 (path);
#line 5604 "SnapshotRepo.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 1026 "Core/SnapshotRepo.vala"
		e = _inner_error0_;
#line 1026 "Core/SnapshotRepo.vala"
		_inner_error0_ = NULL;
#line 1045 "Core/SnapshotRepo.vala"
		_tmp24_ = e;
#line 1045 "Core/SnapshotRepo.vala"
		_tmp25_ = _tmp24_->message;
#line 1045 "Core/SnapshotRepo.vala"
		tee_jee_logging_log_error (_tmp25_, FALSE, FALSE);
#line 1026 "Core/SnapshotRepo.vala"
		_g_error_free0 (e);
#line 5624 "SnapshotRepo.c"
	}
	__finally0:
#line 1026 "Core/SnapshotRepo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1026 "Core/SnapshotRepo.vala"
		_g_free0 (std_err);
#line 1026 "Core/SnapshotRepo.vala"
		_g_free0 (std_out);
#line 1026 "Core/SnapshotRepo.vala"
		_g_free0 (cmd);
#line 1026 "Core/SnapshotRepo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1026 "Core/SnapshotRepo.vala"
		g_clear_error (&_inner_error0_);
#line 1026 "Core/SnapshotRepo.vala"
		return;
#line 5641 "SnapshotRepo.c"
	}
#line 1020 "Core/SnapshotRepo.vala"
	_g_free0 (std_err);
#line 1020 "Core/SnapshotRepo.vala"
	_g_free0 (std_out);
#line 1020 "Core/SnapshotRepo.vala"
	_g_free0 (cmd);
#line 5649 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_construct (GType object_type)
{
	SnapshotRepo * self = NULL;
#line 32 "Core/SnapshotRepo.vala"
	self = (SnapshotRepo*) g_object_new (object_type, NULL);
#line 32 "Core/SnapshotRepo.vala"
	return self;
#line 5660 "SnapshotRepo.c"
}

SnapshotRepo*
snapshot_repo_new (void)
{
#line 32 "Core/SnapshotRepo.vala"
	return snapshot_repo_construct (TYPE_SNAPSHOT_REPO);
#line 5668 "SnapshotRepo.c"
}

gchar*
snapshot_repo_get_timeshift_path (SnapshotRepo* self)
{
	gchar* result;
#line 162 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "Core/SnapshotRepo.vala"
	if (self->btrfs_mode) {
#line 5679 "SnapshotRepo.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 164 "Core/SnapshotRepo.vala"
		_tmp0_ = self->mount_path;
#line 164 "Core/SnapshotRepo.vala"
		_tmp1_ = tee_jee_file_system_path_combine (_tmp0_, "timeshift-btrfs");
#line 164 "Core/SnapshotRepo.vala"
		result = _tmp1_;
#line 164 "Core/SnapshotRepo.vala"
		return result;
#line 5690 "SnapshotRepo.c"
	} else {
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 167 "Core/SnapshotRepo.vala"
		_tmp2_ = self->mount_path;
#line 167 "Core/SnapshotRepo.vala"
		_tmp3_ = tee_jee_file_system_path_combine (_tmp2_, "timeshift");
#line 167 "Core/SnapshotRepo.vala"
		result = _tmp3_;
#line 167 "Core/SnapshotRepo.vala"
		return result;
#line 5702 "SnapshotRepo.c"
	}
}

gchar*
snapshot_repo_get_snapshots_path (SnapshotRepo* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 173 "Core/SnapshotRepo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "Core/SnapshotRepo.vala"
	_tmp0_ = snapshot_repo_get_timeshift_path (self);
#line 174 "Core/SnapshotRepo.vala"
	_tmp1_ = _tmp0_;
#line 174 "Core/SnapshotRepo.vala"
	_tmp2_ = _tmp1_;
#line 174 "Core/SnapshotRepo.vala"
	_tmp3_ = tee_jee_file_system_path_combine (_tmp2_, "snapshots");
#line 174 "Core/SnapshotRepo.vala"
	_tmp4_ = _tmp3_;
#line 174 "Core/SnapshotRepo.vala"
	_g_free0 (_tmp2_);
#line 174 "Core/SnapshotRepo.vala"
	result = _tmp4_;
#line 174 "Core/SnapshotRepo.vala"
	return result;
#line 5733 "SnapshotRepo.c"
}

static void
snapshot_repo_class_init (SnapshotRepoClass * klass,
                          gpointer klass_data)
{
#line 32 "Core/SnapshotRepo.vala"
	snapshot_repo_parent_class = g_type_class_peek_parent (klass);
#line 32 "Core/SnapshotRepo.vala"
	g_type_class_adjust_private_offset (klass, &SnapshotRepo_private_offset);
#line 32 "Core/SnapshotRepo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_snapshot_repo_get_property;
#line 32 "Core/SnapshotRepo.vala"
	G_OBJECT_CLASS (klass)->finalize = snapshot_repo_finalize;
#line 32 "Core/SnapshotRepo.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SNAPSHOT_REPO_TIMESHIFT_PATH_PROPERTY, snapshot_repo_properties[SNAPSHOT_REPO_TIMESHIFT_PATH_PROPERTY] = g_param_spec_string ("timeshift-path", "timeshift-path", "timeshift-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Core/SnapshotRepo.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SNAPSHOT_REPO_SNAPSHOTS_PATH_PROPERTY, snapshot_repo_properties[SNAPSHOT_REPO_SNAPSHOTS_PATH_PROPERTY] = g_param_spec_string ("snapshots-path", "snapshots-path", "snapshots-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5752 "SnapshotRepo.c"
}

static void
snapshot_repo_instance_init (SnapshotRepo * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 32 "Core/SnapshotRepo.vala"
	self->priv = snapshot_repo_get_instance_private (self);
#line 34 "Core/SnapshotRepo.vala"
	self->device = NULL;
#line 35 "Core/SnapshotRepo.vala"
	self->device_home = NULL;
#line 36 "Core/SnapshotRepo.vala"
	_tmp0_ = g_strdup ("");
#line 36 "Core/SnapshotRepo.vala"
	self->mount_path = _tmp0_;
#line 38 "Core/SnapshotRepo.vala"
	self->btrfs_mode = FALSE;
#line 43 "Core/SnapshotRepo.vala"
	_tmp1_ = g_strdup ("");
#line 43 "Core/SnapshotRepo.vala"
	self->status_message = _tmp1_;
#line 44 "Core/SnapshotRepo.vala"
	_tmp2_ = g_strdup ("");
#line 44 "Core/SnapshotRepo.vala"
	self->status_details = _tmp2_;
#line 48 "Core/SnapshotRepo.vala"
	self->priv->parent_window = NULL;
#line 49 "Core/SnapshotRepo.vala"
	self->priv->thr_success = FALSE;
#line 50 "Core/SnapshotRepo.vala"
	self->priv->thr_running = FALSE;
#line 51 "Core/SnapshotRepo.vala"
	_tmp3_ = g_strdup ("");
#line 51 "Core/SnapshotRepo.vala"
	self->priv->thr_args1 = _tmp3_;
#line 5793 "SnapshotRepo.c"
}

static void
snapshot_repo_finalize (GObject * obj)
{
	SnapshotRepo * self;
#line 32 "Core/SnapshotRepo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SNAPSHOT_REPO, SnapshotRepo);
#line 34 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->device);
#line 35 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->device_home);
#line 36 "Core/SnapshotRepo.vala"
	_g_free0 (self->mount_path);
#line 37 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->mount_paths);
#line 40 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->snapshots);
#line 41 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->invalid_snapshots);
#line 43 "Core/SnapshotRepo.vala"
	_g_free0 (self->status_message);
#line 44 "Core/SnapshotRepo.vala"
	_g_free0 (self->status_details);
#line 48 "Core/SnapshotRepo.vala"
	_g_object_unref0 (self->priv->parent_window);
#line 51 "Core/SnapshotRepo.vala"
	_g_free0 (self->priv->thr_args1);
#line 32 "Core/SnapshotRepo.vala"
	G_OBJECT_CLASS (snapshot_repo_parent_class)->finalize (obj);
#line 5824 "SnapshotRepo.c"
}

static GType
snapshot_repo_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SnapshotRepoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) snapshot_repo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SnapshotRepo), 0, (GInstanceInitFunc) snapshot_repo_instance_init, NULL };
	GType snapshot_repo_type_id;
	snapshot_repo_type_id = g_type_register_static (G_TYPE_OBJECT, "SnapshotRepo", &g_define_type_info, 0);
	SnapshotRepo_private_offset = g_type_add_instance_private (snapshot_repo_type_id, sizeof (SnapshotRepoPrivate));
	return snapshot_repo_type_id;
}

GType
snapshot_repo_get_type (void)
{
	static volatile gsize snapshot_repo_type_id__volatile = 0;
	if (g_once_init_enter (&snapshot_repo_type_id__volatile)) {
		GType snapshot_repo_type_id;
		snapshot_repo_type_id = snapshot_repo_get_type_once ();
		g_once_init_leave (&snapshot_repo_type_id__volatile, snapshot_repo_type_id);
	}
	return snapshot_repo_type_id__volatile;
}

static void
_vala_snapshot_repo_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SnapshotRepo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SNAPSHOT_REPO, SnapshotRepo);
#line 32 "Core/SnapshotRepo.vala"
	switch (property_id) {
#line 32 "Core/SnapshotRepo.vala"
		case SNAPSHOT_REPO_TIMESHIFT_PATH_PROPERTY:
#line 32 "Core/SnapshotRepo.vala"
		g_value_take_string (value, snapshot_repo_get_timeshift_path (self));
#line 32 "Core/SnapshotRepo.vala"
		break;
#line 32 "Core/SnapshotRepo.vala"
		case SNAPSHOT_REPO_SNAPSHOTS_PATH_PROPERTY:
#line 32 "Core/SnapshotRepo.vala"
		g_value_take_string (value, snapshot_repo_get_snapshots_path (self));
#line 32 "Core/SnapshotRepo.vala"
		break;
#line 5871 "SnapshotRepo.c"
		default:
#line 32 "Core/SnapshotRepo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "Core/SnapshotRepo.vala"
		break;
#line 5877 "SnapshotRepo.c"
	}
}

static GType
snapshot_location_status_get_type_once (void)
{
	static const GEnumValue values[] = {{SNAPSHOT_LOCATION_STATUS_NOT_SELECTED, "SNAPSHOT_LOCATION_STATUS_NOT_SELECTED", "not-selected"}, {SNAPSHOT_LOCATION_STATUS_NOT_AVAILABLE, "SNAPSHOT_LOCATION_STATUS_NOT_AVAILABLE", "not-available"}, {SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_HAS_SPACE, "SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_HAS_SPACE", "has-snapshots-has-space"}, {SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_NO_SPACE, "SNAPSHOT_LOCATION_STATUS_HAS_SNAPSHOTS_NO_SPACE", "has-snapshots-no-space"}, {SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_NO_SPACE, "SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_NO_SPACE", "no-snapshots-no-space"}, {SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_HAS_SPACE, "SNAPSHOT_LOCATION_STATUS_NO_SNAPSHOTS_HAS_SPACE", "no-snapshots-has-space"}, {SNAPSHOT_LOCATION_STATUS_READ_ONLY_FS, "SNAPSHOT_LOCATION_STATUS_READ_ONLY_FS", "read-only-fs"}, {SNAPSHOT_LOCATION_STATUS_HARDLINKS_NOT_SUPPORTED, "SNAPSHOT_LOCATION_STATUS_HARDLINKS_NOT_SUPPORTED", "hardlinks-not-supported"}, {SNAPSHOT_LOCATION_STATUS_NO_BTRFS_SYSTEM, "SNAPSHOT_LOCATION_STATUS_NO_BTRFS_SYSTEM", "no-btrfs-system"}, {0, NULL, NULL}};
	GType snapshot_location_status_type_id;
	snapshot_location_status_type_id = g_enum_register_static ("SnapshotLocationStatus", values);
	return snapshot_location_status_type_id;
}

GType
snapshot_location_status_get_type (void)
{
	static volatile gsize snapshot_location_status_type_id__volatile = 0;
	if (g_once_init_enter (&snapshot_location_status_type_id__volatile)) {
		GType snapshot_location_status_type_id;
		snapshot_location_status_type_id = snapshot_location_status_get_type_once ();
		g_once_init_leave (&snapshot_location_status_type_id__volatile, snapshot_location_status_type_id);
	}
	return snapshot_location_status_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

